# --- File  : ag_01_crop.tcl
# --- Date  : 12-Mar-2008
# --- By    : Harald Sund
# --- About : Setting for crop in output projection.

# sjekk om variable eksisterer
if {[info exists ag_tmp::panel_crop]} {
  # sjekk om panelet eksisterer
  if [qexists $ag_tmp::panel_crop] {
    qinformation "Warning" "You cannot start multiple sessions of this panel. <BR>The panel is present somewhere"
    return
  }
}

#####################
proc AG_Outline_crop {} {
  sta $ag::xgeomin $ag::ygeomin
  sta $ag::xgeomax $ag::ygeomin
  sta $ag::xgeomax $ag::ygeomax
  sta $ag::xgeomin $ag::ygeomax
  sta $ag::xgeomin $ag::ygeomin
  rea ter
  mak lin pnr 400 cnt
  AG_Make_geotrans
  ssc
  z
  col red
  pol 3
  col yel
  dra dwa
  col whi
  axe gri

  set x1 [gvar xwin]
  set x2 [gvar xwax]
  set y1 [gvar ywin]
  set y2 [gvar ywax]

  set dx [expr $x2 - [expr 0.5 * $x1 + 0.5 * $x2]]
  set dy [expr $y2 - [expr 0.5 * $y1 + 0.5 * $y2]]

  set xx1 [expr $x1 + [expr $dx * $ag::crop_x1] / 100]
  set xx2 [expr $x2 - [expr $dx * $ag::crop_x2] / 100]
  set yy1 [expr $y1 + [expr $dy * $ag::crop_y1] / 100]
  set yy2 [expr $y2 - [expr $dy * $ag::crop_y2] / 100]

  sta $xx1 $yy1
  sta $xx2 $yy1
  sta $xx2 $yy2
  sta $xx1 $yy2
  sta $xx1 $yy1
  rea ter
  col blu
  pol 3
}


# ----------------------#
# ---- Start panel ---- #
# ----------------------#

set ag_tmp::panel_crop [qwidget $ag_tmp::main_panel window] 
qsetattribute deleteonclose
qsetwindowtitle "Settings for crop on output projection"

qgridlayout {
  qsetspacing 0

  qlabel 
  qlabel
  qlabel "North % crop"

  qnewgridline
  qlabel 
  qlabel
  qlineedit
  qblockedtrace ag::crop_y2

  qnewgridline

  qlabel "West % crop"
  qlineedit
  qblockedtrace ag::crop_x1

  qlabel

  qlineedit
  qblockedtrace ag::crop_x2
  qlabel "East % crop"

  qnewgridline
  qlabel 
  qlabel
  qlineedit
  qblockedtrace ag::crop_y1

  qnewgridline
  qlabel 
  qlabel
  qlabel "South % crop"


  qnewgridline
  qsetcolumnspan 5
  qlabel "The range of the above % crop-numbers are 0-100, values outside will be set to either 0 or 100"

  qnewgridline
  qsetcolumnspan 1
  qpushbutton "Preview Outline" {AG_Outline_crop}
  qsetcolumnspan 4
  qlabel "<B><FONT COLOR=#AA0000>Geodetic frame <FONT COLOR=#AAAA00>Full frame, output projection <FONT COLOR=#0000AA>Final crop, output projection"

  qsetmargin 2
}
qshow $ag_tmp::panel_crop

# --- eof
