# --- File  : ag_directory_setup.tcl
# --- Date  : 27-Jun-2007
# --- By    : Harald Sund
# --- About : Save current directories as an init-file for AG.


set file $ag_tmp::geocaprc/ag_init.tcl

set button [qinformation "Save directory settings" "<P>Paths to be saved:\
  <P>Area root directory:\
  <BR><B>$ag_tmp::dir</B>\
  <P>Master Data root directory:\
  <BR><B>$ag_tmp::master_data_path</B>\
  <P>Alternative location for <b>grid2vtk.exe</b>:\
  <BR><B>$ag_tmp::grid2vtk_located</B>\

  <P>This will be saved in file:\
  <BR><B>$file</B>\
  <P>Pressing 'Continue' you will save these settings." "Continue" "Cancel"]
if {$button == 1} {
  return
} else {
  set Outfile [open $file w]
  puts $Outfile {# This is a file generated by the Area Generator in Geocap}
  puts $Outfile {# It contains folder settings for the root directory for the}
  puts $Outfile {# Master Data and the Area}
  puts $Outfile "set area_path {$ag_tmp::dir}"
  puts $Outfile "set master_data_path {$ag_tmp::master_data_path}"
  puts $Outfile "set grid2vtk_loc {$ag_tmp::grid2vtk_located}"
  puts $Outfile {# --- eof} 
  close $Outfile
}

# --- eof
