# --- File  : ag_generate_area.tcl
# --- Date  : 04-Dec-2006
# --- By    : Harald Sund
# --- About : Panel for generating unclos areas

# IDE: lag clipper-polygon og clipper-exe til hvert omrde.
# Man kan ha mange polygoner og en 'shared commad' som gjr en
# 'make active' p hver av dem - dvs mhi clip_polygon.

set ag_tmp::passes_dateline 0

AG_Error_check
if {$ag_tmp::errorcheck == 1} {return}

if {$ag_tmp::dir == "Not selected"} {
  qinformation "Area Generator Error Message" "The Root directory is not selected. You have to select a Root directory first!"
  return
}
if {$ag::area_name == ""} {
  qinformation "Area Generator Error Message" "The Area name cannot be blank!"
  return
}

if {$ag_tmp::master_data_path == "Not selected"} {
  qinformation "Area Generator Error Message" "The Master data directory is not selected. You have to select a master_data directory first!"
  return
}

cd $ag_tmp::dir
AG_Set_silent_mode $ag_tmp::silent_mode

if [file exists "$ag_tmp::dir/$ag::area_name/etopo2"] {
  # ----------------------#
  # ---- Start panel ---- #
  # ----------------------#
  set ag_tmp::panel_recreate_area [qwidget $ag_tmp::main_panel window] 
  qsetattribute deleteonclose
  qsetwindowtitle "Area Generator Warning"

  qgridlayout {
    qsetspacing 0
    qlabel "<B>The Area '${ag::area_name}' already exists!!! </B>
 
    <P>It is not possible
       to overwrite a existing area.<BR>You must either:

      <OL>
      <LI> Rename your directory in disk
      <LI> Remove your directory on disk
      <LI> Change the name of your Area to
       <BR>something other than current name:
       <BR> <B> \" $ag::area_name \" </B>
      <LI> Press the button below to partly
       <BR>remove automatic generated content
       <BR>of the area on disk
      </OL>"

      qnewgridline
      qpushbutton "Remove the area from disk" {
        file delete -force "$ag::area_name/etopo2"
        set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Directories
          <BR> $ag_tmp::dir/$ag::area_name/etopo2
          <BR>removed."
        qdelete $ag_tmp::panel_recreate_area
      }
      qnewgridline
      qpushbutton "No action" {
        qdelete $ag_tmp::panel_recreate_area
      }
      qsetmargin 5
  }
  qshow $ag_tmp::panel_recreate_area
} else {
  if [file exists "$ag_tmp::dir/$ag::area_name"] {
    AG_Create_area partly
  } else {
    AG_Create_area all
  }
}

# --- eof