# --- File  : ag_index.tcl
# --- Date  : 01-Mar-2005
# --- By    : Harald Sund
# --- About : Panel for generating unclos areas (Area Generator)

#spe lco off
#qinformation "Warning" "Local origio is now turned off"

# Midlertidig fiks, t.o.m. 4.2.129 - fikser mhi app - problemet.
#val i 200 1551 - virker ikke

if [namespace exists ag] {
  #  namespace delete ag
  #  namespace delete ag_tmp

  # sjekk om variable/paneler eksisterer
  if {[info exists ag_tmp::main_panel]} {
    # sjekk om panelet eksisterer
    if [info exists areageneratorpanel] {
      set areageneratorpanel 3
    } else {
      set areageneratorpanel 1
    }
    if [qexists $ag_tmp::main_panel] {
      if {$areageneratorpanel == 3} {
        qdelete $ag_tmp::main_panel
        #qinformation "Warning" "The Area Generator panel is now deleted. Restart the Area Generator"
##SM        source $ag_tmp::path/index.tcl 
      } else {
        qinformation "Warning" "You cannot start multiple sessions of Area Generator. <BR>The panel is present somewhere"
      }
      return
    }
  }
} else {
  # alts det har ikke vrt oppe fr. Skjer bare frste gang...
  namespace eval ag {}
  namespace eval ag_tmp {}
  set ag_tmp::dir "Not selected"
  set ag_tmp::master_data_path "Not selected"
  #set ag::projection "Mercator"
  #set ag::central_mer 0
}


set f $Geocap::homedir/geocaprc-[geocapversion major].[geocapversion minor]
if {[geocapversion major] == 6 && [geocapversion minor] == 5} {
  set f $Geocap::homedir/geocaprc-6.4
}
if [file exists $f] {
  # do nothing, that is OK
} else {
  set f $Geocap::homedir/geocaprc-[geocapversion major]
}
set ag_tmp::geocaprc $f

set file $ag_tmp::geocaprc/ag_init.tcl
if [file exists $file] {
  source $file
}

##############################
proc AG_Info_on_dirs {line1} {
  qinformation "Error (Area Generator)" "$line1
  Edit file:
  $ag_tmp::geocaprc/ag_init.tcl

  or browse in new folders. You may want to use
  Tools > Save directory setup ... afterwards."
}

##############################
proc AG_Select-deselect {0_or_1} {
  set ag::generate_etopo1grid $0_or_1
  set ag::generate_emag2grid $0_or_1
  set ag::generate_ginagrid $0_or_1
  set ag::generate_s2004grid $0_or_1
  set ag::generate_srtm30plusgrid $0_or_1
  set ag::generate_gebcogrid $0_or_1
  set ag::generate_kms2002grid $0_or_1
  set ag::generate_wdmam_ngdc_v1_1_mf5 $0_or_1
  set ag::generate_wdmam_ngdc_v1_1 $0_or_1
  set ag::generate_emag2_v2 $0_or_1
  set ag::generate_glob_sat_grav $0_or_1
  set ag::generate_glob_sat_vert_grav_grad $0_or_1
  set ag::create_coastline $0_or_1
  set action "Create inside window"
  set ag::include_multibeam "Include multibeam"

  if {$0_or_1 == 0} {set action "Skip"}
  set ag::create_bgr $action
  set ag::create_bsh $action
  set ag::create_ga_gov_au $action
  set ag::create_geodas $action
  set ag::create_gmbd $action
  set ag::create_ifremer $action
  set ag::create_ipgs $action
  set ag::create_jamstec $action
  set ag::create_jodc $action
  set ag::create_mg_dms $action
  set ag::create_seadog $action
  set ag::create_scripps $action
  set ag::create_un_boundaries_01 $action
  set ag::create_utig $action
  set ag::create_usgs $action
  set ag::create_whoi $action
  set ag::create_ecs $action
  set ag::create_wvsplus $action
  set ag::create_industry $action
  if {$0_or_1 == 0} {set ag::include_multibeam "Skip all multibeam"}
}

if {[info exists area_path]} {
  if {$ag_tmp::dir == "Not selected"} {
    set dirname [file tail $area_path]
    if {$dirname == "area" || $dirname == "Area"} {
      if {[file exists $area_path]} {
        set ag_tmp::dir $area_path
        cd $area_path
      } else {
        AG_Info_on_dirs "The area folder $area_path does not exist"
      }
    } else {
      AG_Info_on_dirs "The area folder is called '$dirname' but must be called 'area'"
    }
  }
}

if {[info exists master_data_path]} {
  if {$ag_tmp::master_data_path == "Not selected"} {
    set dirname [file tail $master_data_path]
    if {$dirname == "master_data"} {
      if {[file exists $master_data_path]} {
        set ag_tmp::master_data_path $master_data_path
      } else {
        AG_Info_on_dirs "The master data folder $master_data_path does not exist"
      }
    } else {
      AG_Info_on_dirs "The master data folder is called '$dirname' but must be called 'master_data'"
    }
  }
}

set ag_tmp::path $init_src_dir
# Jeg m ha Area Generator p H-disken min...
# Fra n av ligger master alltid p H:/
# For andre skal det ligge p C:/Users/..../geocaprc-7/userscripts/Area_Generator/
if [file exists "H:/Geocap/Area Generator/dev"] {set ag_tmp::path "H:/Geocap/Area Generator/dev"}

source $ag_tmp::path/ag_date.tcl

set ag_tmp::label1 "<B><FONT COLOR=#0000AA>
      <FONT COLOR=#AA0000>Area Generator<FONT COLOR=#0000AA>.
      <BR>Copyright (c) 2005 - 2013
      <BR>UNEP Shelf Programme/Grid Arendal and Geocap AS"

source $ag_tmp::path/ag_init_var.tcl
if [info exists grid2vtk_loc] {
    set ag_tmp::grid2vtk_located $grid2vtk_loc
} else {
    set ag_tmp::grid2vtk_located $ag_tmp::path/progs/grid2vtk.exe
}


source $ag_tmp::path/ag_procs.tcl
AG_Check_if_shelf_is_loaded

# pner og lukker geodesywidget for at variable skal settes.
set ag_tmp::geodesywidget [geodesywidget]
qshow $ag_tmp::geodesywidget
qdelete $ag_tmp::geodesywidget

# ----------------------#
# ---- Start panel ---- #
# ----------------------#

# ... as a child of [mainwindow]
set ag_tmp::main_panel [qmainwindow [mainwindow]]

qsetattribute deleteonclose
qsetwindowtitle "$ag_tmp::prog_name"

# --- Pulldowns
set ag_tmp::minimized 0
source $ag_tmp::path/ag_pulldowns.tcl

qsetcentralwidget $ag_tmp::main_panel [qwidget]

qgridlayout {
  qsetspacing 0 ;# margin in pixes between widgets

  qgroupbox "Decimal degrees, West to East: -180 to 180, South to North: -90 to 90" 
  AG_Menubox_1

  qgroupbox "Area name and AG directories" 
  qgridlayout {
    qlabel "Area root directory (output)"
    qlabel " : "
    qlabel
    qblockedtrace ag_tmp::dir
    qsettooltip "This is the root directory. Any new area will
appear as a subdirectory to the root directory. The root directory should
be called something like ......./area"

    qpushbutton "Browse" {
      AG_My_open_a_agdir area
    }
    qsettooltip "This is the root directory. Any new area created will
appear as a subdirectory to the root directory. The root directory must
be called something like ./bla bla/whatever/Area ."
    qseticon [qicon $ag_tmp::path/icons/fileopen.xpm]

    qnewgridline
    qlabel "Master data directory"
    qlabel " : "
    qlabel
    qblockedtrace ag_tmp::master_data_path
    qsettooltip "This is the root directory for the master data. The master data folder structure
must not be changed. The master data directory is called
something like .............../master_data"

    qpushbutton "Browse" {
      AG_My_open_a_agdir master_data
      qclose $ag_tmp::main_panel
##SM      source $ag_tmp::path/index.tcl 
    }
    qsettooltip "This is the root directory for the master data. The master data folder structure
must not be changed. The master data directory is called
something like .............../master_data"
    qseticon [qicon $ag_tmp::path/icons/fileopen.xpm]
    qnewgridline

    qlabel "New Area name"
    qlabel " : "
    qlineedit
    qblockedtrace ag::area_name

    qpushbutton "Generate Area" {
      if {$ag_tmp::debug == 1} {
        AG_Set_silent_mode 0
        set ag_tmp::silent_mode 0
      }
      source $ag_tmp::path/ag_generate_area.tcl
    }

    qnewgridline
    qlabel
    qlabel
    qlabel "NB! No special (e.g. national) characters in folder names!!"
    AG_Build_project_button
    qsetspacing 0 ;# margin in pixes between widgets
  }

  qnewgridline

  qgroupbox "Output Geodetics" 
  qgridlayout {
    set ag_tmp::geodesywidget [geodesywidget]
    qsetspacing 0 ;# margin in pixes between widgets
  }
  qsetspacing 0 ;# margin in pixes between widgets

  qgroupbox "Data labeled in RED are NOT AVAILABLE in master_data and WILL BE SKIPPED" 
  qgridlayout {

    set link "www.bgr.bund.de/EN"
    set txt "BGR"
    qpushbutton "" "AG_open_browser $link"
    qsettooltip "$link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    if [file exist $ag_tmp::master_data_path/BGR] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>$txt"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window"}
    qseteditable 1
    qsetspacing 0 ;# margin in pixes between widgets
    qblockedtrace ag::create_bgr
    qsettooltip "$link"

    qlabel " "

    set link "www.bsh.de/en"
    set txt "BSH"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/BSH] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>BSH"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window"} 
    qseteditable 1
    qblockedtrace ag::create_bsh

    qnewgridline

    set link "www.ga.gov.au"
    set txt "GA_GOV_AU"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/GA_GOV_AU] {
      qlabel "GA_GOV_AU"
    } else {
      qlabel "<FONT COLOR=#AA0000>GA_GOV_AU"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window"} 
    qseteditable 1
    qblockedtrace ag::create_ga_gov_au

    qlabel " "

    set link "www.ngdc.noaa.gov/mgg/geodas"
    set txt "Geodas"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/Geodas] {
	qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>$txt"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window"}
    qseteditable 1
    qblockedtrace ag::create_geodas

    qnewgridline

    set link "www.MaritimeBoundaries.com"
    set txt "GMDB"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/GMBD] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>$txt"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window" "Create complete surveys"} 
    qblockedtrace ag::create_gmbd
    #qlabel "Global Maritime Boundaries DB"

    qlabel
    set link "www.ifremer.fr/sismer/index_UK.htm"
    set txt "Ifremer"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/Ifremer] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>$txt"
    }
    qlabel " : "
    qcombobox
    qseteditable 1
    qadditems {"Skip" "Create inside window"}
    qblockedtrace ag::create_ifremer

    qnewgridline

    set link "http://eost.u-strasbg.fr/IPGS/"
    set txt "IPGS"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/IPGS] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>$txt"
    }

    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window"} 
    qseteditable 1
    qblockedtrace ag::create_ipgs
    qsettooltip "http://eost.u-strasbg.fr/IPGS/"

    qlabel
    set link "www.jamstec.go.jp/e/"
    set txt "JAMSTEC"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/JAMSTEC] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>$txt"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window"} 
    qseteditable 1
    qblockedtrace ag::create_jamstec

    qnewgridline

    set link "www.jodc.go.jp/"
    set txt "JODC"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/JODC] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>$txt"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window"} 
    qseteditable 1
    qblockedtrace ag::create_jodc

    qlabel
    set link "www.marine-geo.org"
    set txt "MG_DMS"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/MG_DMS] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>$txt"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window"}
    qseteditable 1
    qsetspacing 0 ;# margin in pixes between widgets
    qblockedtrace ag::create_mg_dms
    #qlabel "Lamont Doherty"

    qnewgridline

    set link "www.noc.soton.ac.uk/gg/facilities/seadog.php"
    set txt "SeaDOG"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/SeaDOG] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>$txt"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window"} 
    qseteditable 1
    qblockedtrace ag::create_seadog

    qlabel
    set link "http://nsdl.sdsc.edu"
    set txt "Scripps"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/Scripps] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>$txt"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window"} 
    qseteditable 1
    qblockedtrace ag::create_scripps

    qnewgridline

    set link "http://www.npd.no"
    set txt "Norway Sea"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/Norway] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>$txt"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window"} 
    qseteditable 0
    qblockedtrace ag::create_norway_sea

    qlabel
    set link "http://www.npd.no"
    set txt "Norway Land"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/Norway] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>$txt"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window"} 
    qseteditable 0
    qblockedtrace ag::create_norway_land

    qnewgridline

    set link "www.un.org/Depts/los/clcs_new/clcs_home.htm"
    set txt "Submission ECS"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/ECS] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>Submission $txt"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window" "Create complete surveys"} 
    qblockedtrace ag::create_ecs

    #qcheckbox "Include multibeam"
    #qblockedtrace ag::include_multibeam

    qlabel
    set link "http://marine.usgs.gov/"
    set txt "USGS"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/USGS] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>$txt"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window"}
    qseteditable 1
    qsetspacing 0 ;# margin in pixes between widgets
    qblockedtrace ag::create_usgs

    qnewgridline

    set link "www.whoi.edu/"
    set txt "WHOI"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/WHOI] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>WHOI"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window"} 
    qseteditable 1
    qblockedtrace ag::create_whoi


    qlabel
    set link "http://boundaries.ungiwg.org/"
    set txt "UN_Boundaries_01"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/UN_Boundaries_01] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>$txt"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window" "Create complete surveys"} 
    qblockedtrace ag::create_un_boundaries_01

    qnewgridline

    set link "www.ig.utexas.edu/sdc/"
    set txt "UTIG"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/UTIG] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>$txt"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window"}
    qseteditable 1
    qsetspacing 0 ;# margin in pixes between widgets
    qblockedtrace ag::create_utig

    qlabel
    qlabel
    qlabel "Global setting"
    qlabel " : "
    qcombobox
    qadditems {"Include multibeam" "Generate multibeam only" "Skip all multibeam"}
    qblockedtrace ag::include_multibeam

    qnewgridline

    set link "www.ngdc.noaa.gov"
    set txt "Coastline: wvsplus"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    if [file exist $ag_tmp::master_data_path/Coastline/wvsplus] {
      qlabel "$txt"
    } else {
      qlabel "<FONT COLOR=#AA0000>$txt"
    }
    qlabel " : "
    qcombobox
    qadditems {"Skip" "Create inside window" "Create complete surveys"} 
    qseteditable 1
    qblockedtrace ag::create_wvsplus

    qlabel ""
    qlabel ""
    qlabel ""
    qlabel ""
    qcheckbox "Global Select/Deselect" {AG_Select-deselect}

    qnewgridline
    qlabel
    qlabel "Industry"
    qlabel " : "
    qcombobox
    qseteditable 1
    qadditems {"Skip" "Create inside window"}
    qblockedtrace ag::create_industry
    qsettooltip "Whatever is in folder Industry"

    qlabel ""
    qlabel ""
    qlabel ""
    qlabel ""
    set ag_tmp::silent_mode 1
    qcheckbox "Silent mode" {AG_Set_silent_mode}
    qblockedtrace ag_tmp::silent_mode
    qsettooltip "Reduced message output"

    #qcheckbox "Tracklines only"
    #qblockedtrace ag::only_tracklines
    #qsettooltip "This is valid for Geodas, Ifremer, SeaDOG and MG_DMS only. Other selected
    #data sources will not be affected by checking here."
    #set ag::only_tracklines 0
    #qsetenabled 0

    #qpushbutton "rm dirs" {AG_Delete_empty_subfolders_recursively $ag_tmp::dir/$ag::area_name/ag_files}
  }

  qnewgridline

  qsetcolumnspan 2
  qgroupbox "Include global grids/datasets - Data NOT AVAILABLE in the master_data/Global_Grid folder WILL BE SKIPPED even if selected below." 
  qgridlayout {
    set link "www.ngdc.noaa.gov/mgg/global/global.html"
    set txt "Etopo1"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"

    qcheckbox "Etopo1"
    qblockedtrace ag::generate_etopo1grid

    set link "www.gina.alaska.edu/"
    set txt "Gina"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    qcheckbox "$txt"
    qblockedtrace ag::generate_ginagrid

    set link "ftp://falcon.grdl.noaa.gov/pub/walter/Gebco_SandS_blend.bi2"
    set txt "s2004"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    qcheckbox "$txt"
    qblockedtrace ag::generate_s2004grid

    set link "http://topex.ucsd.edu/"
    set txt "SRTM30plus"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    qcheckbox "$txt"
    qblockedtrace ag::generate_srtm30plusgrid

    set link "www.bodc.ac.uk/products/bodc_products/gebco/"
    set txt "Gebco"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    qcheckbox "$txt"
    qblockedtrace ag::generate_gebcogrid

    set link "www.spacecenter.dk/data/global-marine-free-air-gravity-field-1/"
    set txt "KMS2002"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    qcheckbox "$txt"
    qblockedtrace ag::generate_kms2002grid

    # nsker alltid  dra inn sediment thickness
    #qcheckbox "Sediment thickness"
    #qblockedtrace ag::generate_sedimentgrids
    #qsettooltip "http://www.ngdc.noaa.gov/mgg/sedthick/"
    #Etopo2
    #qsettooltip "http://www.ngdc.noaa.gov/mgg/fliers/01mgg04.html"

#    qcheckbox "WDMAM.ngdc.v1.1.MF5"
#    qblockedtrace ag::generate_wdmam_ngdc_v1_1_mf5
#    qsettooltip "http://www.geomag.us/models/wdmam.html"

    set link "www.geomag.us/models/wdmam.html"
    set txt "WDMAM.ngdc"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    qcheckbox "WDMAM.ngdc"
    qblockedtrace ag::generate_wdmam_ngdc_v1_1

    set link "www.geomag.us/models/emag2.html"
    set txt "EMAG2_V2"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    qcheckbox "$txt"
    qblockedtrace ag::generate_emag2_v2

    set link "http://topex.ucsd.edu/WWW_html/mar_grav.html"
    set txt "Glob.Sat.Grav."
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    qcheckbox "$txt"
    qblockedtrace ag::generate_glob_sat_grav

#    qcheckbox "Glob.Sat.Vert.Grav.Grad"
#    qblockedtrace ag::generate_glob_sat_vert_grav_grad
#    qsettooltip "http://topex.ucsd.edu/WWW_html/mar_grav.html"

    set link "www.ngdc.noaa.gov/mgg/shorelines/gshhs.html"
    set txt "gshhs Coast line"
    qpushbutton "" "AG_open_browser $link"
    qseticon [qicon $ag_tmp::path/icons/www2.png]
    qsettooltip "$link"
    qcheckbox "$txt"
    qblockedtrace ag::create_coastline

    set ag::create_limitlines 0
    #Undvendig, skal alltid med
    #qcheckbox "2500m line"
    #qblockedtrace ag::create_2500m_line
    #qcheckbox "State borders"
    #qblockedtrace ag::create_stateborders
    ##qcheckbox "Coarse FlatEarth 200M+350M"
    ##qblockedtrace ag::create_limitlines
    ##qsetenabled 0 

    qsetspacing 0 ;# margin in pixes between widgets
  }

  qnewgridline

  qsetcolumnspan 2
  qgroupbox "" 
  qgridlayout {
    qsetspacing 0 ;# margin in pixes between widgets
    qlabel
    qblockedtrace ag_tmp::label1
  }
  qsetspacing 0 ;# margin in pixes between widgets
  set areageneratorpanel 1
}
qshow $ag_tmp::main_panel

# --- eof
