# --- File  : ag_init_var.tcl
# --- Date  : 29-Nov-2005
# --- By    : Harald Sund
# --- About : Initialize variables

if {[info exists ag::xgeomin]} {
  # do not declare variables
} else {
  set ag::xgeomin ""
  set ag::xgeomax ""
  set ag::ygeomin ""
  set ag::ygeomax ""
}

set ag_tmp::passes_dateline 0
set ag::crop_x1 0
set ag::crop_x2 0
set ag::crop_y1 0
set ag::crop_y2 0
set ag_tmp::debug 0
set ag::skip_accumulating 0
set ag::use_lines_in_testcoast 0
set ag::skip_wells 0
set ag::skip_filepointers 0
set ag::skip_sorting_coast 0
set ag::etopo2_display_minimum 0
set ag::only_tracklines 1
set ag::create_limitlines 0
set ag::create_2500m_line 1
set ag::create_stateborders 1
#set ag::create_coastline 1
set ag::display_tracklines 0
set ag::etopo2_display_reduced 0
set ag::etopo2_display_smooth 1
set ag::etopo2_reduce_land_height 0
set ag::etopo2_skip_land_display 0
set ag::pen_color "yel"
set ag::pen_width "1"

set ag_tmp::use_master_data_path 0

#set ag_tmp::projection_2bset "Mercator"
#set ag::hemisphere "N"
#set ag::utm_zone 31
#set ag::truelat 75

#geodesywidget setdatum $ag_tmp::geodesywidget "WGE     World Geodetic System 1984"
#geodesywidget setcentralmeridian $ag_tmp::geodesywidget 0
#geodesywidget setoriginlatitude $ag_tmp::geodesywidget 0
#geodesywidget setfalseeasting $ag_tmp::geodesywidget 0
#geodesywidget setfalsenorthing $ag_tmp::geodesywidget 0

set ag::gw_datum "WGE     World Geodetic System 1984"
set ag::gw_coordinatesystem "Mercator"
set ag::gw_centralmeridian "0"
set ag::gw_originlatitude "0"
set ag::gw_falseeasting "0"
set ag::gw_falsenorthing  "0"
set ag::gw_longitudedown "0"
set ag::gw_latitudetruescale "75"
set ag::gw_firststdparallel "71"
set ag::gw_secondstdparallel "90"
set ag::gw_utmzone "31"
set ag::gw_hemisphere "N"
set ag::gw_scalefactor "1"
set ag::gw_longitudeone 5
set ag::gw_longitudetwo 5
set ag::gw_latitudeone 40
set ag::gw_latitudetwo 60

# --- eof
