# --- File  : ag_preview_topo.tcl
# --- Date  : 26-Jun-2007
# --- By    : Harald Sund
# --- About : Preview geographic area, Coastline and state borders

d3
set ag_tmp::passes_dateline 0

AG_Error_check
if {$ag_tmp::errorcheck == 1} {return}

if {$ag_tmp::previewtype == "srtm"} {
  AG_Read_global_grid SRTM15plus_V1 nostore
} elseif [file exist $ag_tmp::master_data_path/Global_Grids/ETOPO1_Ice_g.vtk] {
  AG_Read_global_grid ETOPO1_Ice_g nostore
} else {
  AG_Read_global_grid ETOPO2v2 nostore
}

mhi etopo2  ;# Ikke ndvendigvis etopo2grid her, faktisk nesten aldri.

ssc
zz
#dra dwa
scaz 25

if {[gvar zmax] > 1} {
  # ... ellers har jeg ikke noe hav...
  ctable set Sea
  if {$ag_tmp::previewtype == "map_nor"}   {clip z 0; map nor}
  if {$ag_tmp::previewtype == "lod" || $ag_tmp::previewtype == "srtm"} {eli lt 0; lod map}
  if {$ag_tmp::previewtype == "lod_range"} {
    eli lt 0
    set d [expr 0.3 * [gvar zmax] - 0.3 * [gvar zmin]]
#    lod map range [expr [gvar zmin] + $d]  [expr [gvar zmax] - $d] showfullresmesh
    lod map range [expr [gvar zmin] + $d]  [expr [gvar zmax] - $d]
  }
  if {$ag_tmp::previewtype == "lod_reduced_land"} {
    eli lt 0
    set d [expr 0.2 * [gvar zmax] - 0.2 * [gvar zmin]]
    #lod map range [expr [gvar zmin] + $d]  [expr [gvar zmax] - $d] contour_values 
    lod map  range [expr [gvar zmin] + $d]  [expr [gvar zmax] - $d]  color_filling_method continous show_contour_lines 1 contour_line_color .8 .6 .6 contour_values 21 100 200 300 400 500 1000 1500 2000 2500 3000 3500 4000 4500 5000 5500 6000 6500 7000 7500 8000 8500

#lod map contour_values 21 100 200 300 400 500 1000 1500 2000 2500 3000 3500 4000 4500 5000 5500 6000 6500 7000 7500 8000 8500
  }
  if {$ag_tmp::previewtype == "lod_color"} {
     ctable set Default
     eli lt 0
     lod map
  }
  # --- 200M
  if [file exist $ag_tmp::master_data_path/GMBD] {
    AG_Read_and_convert_lines GMBD/GMBD_Lines_VTK/highseas.vtk relative_path line

    asc ;# mtte legge inn denne for ellers s har det sluttet  virke skikkelig mellom 6.1.1 og 6.3

    if {[gvar numpoint] != 0} {
      mak lin grid etopo2
      zap etopo2
      sub 60
      col pin
      pol 3
      d
      # Veldig merkelig - m tegne opp omigjen for  f tykk linje.
      col pin
      pol 3
    }
  }
}


mlo etopo2

if {[gvar zmin] < -1} {
  # ... ellers har jeg ikke noe land...
  ctable set "Land"
  if {$ag_tmp::previewtype == "map_nor"} {clip z 0 rev; map nor}
  if {$ag_tmp::previewtype == "lod" || $ag_tmp::previewtype == "srtm"}       {eli gt 0; lod map}
  if {$ag_tmp::previewtype == "lod_range"} {ctable set "Seismic RedBlue";eli gt 0; lod map}
  if {$ag_tmp::previewtype == "lod_reduced_land"} {ctable set "Seismic RedBlue";eli gt 0; mul 0.2; lod map}
  if {$ag_tmp::previewtype == "lod_color"} {
    eli gt 0
    #lod dis col .9 .9 .5 showfullresmesh - virker ikke...
    #lod map showfullresmesh
    lod map color_filling_method solid solid_color .9 .9 .9
  }
  ctable set Default

  # --- UN Boundaries
  if [file exist $ag_tmp::master_data_path/UN_Boundaries_01] {

    # Boundaries
    AG_Read_and_convert_lines UN_Boundaries_01/UN_IntBoundaries_01M.vtk relative_path line
    if {[gvar numpoint] != 0} {
      mak lin grid etopo2
      asc ;# mtte legge inn denne for ellers s har det sluttet  virke skikkelig mellom 6.1.1 og 6.3
      zap etopo2
      if {$ag_tmp::previewtype == "lod_reduced_land"} {mul 0.2}

      sub 60
      col yel
      pol 3
    }

#    # Coast
#    AG_Read_and_convert_lines UN_Boundaries_01/UN_Coastline_01M.vtk relative_path line
#    if {[gvar numpoint] != 0} {
#      mak lin grid etopo2
#      zap etopo2
#
#      sub 60
#      col bla
#      pol 3
#      # Veldig merkelig - m tegne opp omigjen for  f tykk linje.
#    }

    AG_Read_and_convert_lines UN_Boundaries_01/UN_Lakes_01M.vtk relative_path line

    if {[gvar numpoint] != 0} {
      mak lin grid etopo2
      asc ;# mtte legge inn denne for ellers s har det sluttet  virke skikkelig mellom 6.1.1 og 6.3
      zap etopo2
      sub 60
      col tur
      pol 3
      # Veldig merkelig - m tegne opp omigjen for  f tykk linje.
    }

  }
}
ctable set Default
ssc h etopo2
set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Preview created and displayed."
# --- eof
