# --- File  : ag_procs.tcl
# --- Date  : 14-Feb-2005
# --- By    : Harald Sund
# --- About : procs

#############################
proc AG_open_browser {link} {
  # Possible to replace by newer syntax, qopenurl or something.

  set tmppath [qtemppath]

  set ag_tmp::bat_file [open $tmppath/geocap_link.bat w]
  puts $ag_tmp::bat_file "\@echo off"
  puts $ag_tmp::bat_file "REM The following will opens the link in your default browser."
  puts $ag_tmp::bat_file "start $link"
  close $ag_tmp::bat_file 

  exec $tmppath/geocap_link.bat
}

#############################
proc AG_Check_if_shelf_is_loaded {} {
  # Get all modules as a list
  set ag_tmp::shelf_loaded 0

  set cmds [info commands] ; # List all commands
  # Find 'she' in this list
  # See if she is there...lsearch is the cmd to find an element in a Tcl list
  set index [lsearch $cmds she]
  # if index is -1 it was not found

  if {$index == -1} {
    puts "Shelf is NOT loaded"
  } else {
    puts "Shelf is loaded"
    set ag_tmp::shelf_loaded 1
  }
}


#############################
proc AG_Check_if_shelf_is_loaded____VIRKER_IKKE {} {
  # Get all modules as a list
  set ag_tmp::shelf_loaded 0

  set mods [package names]

  # show them 
  #puts $mods

  # See if Shelf is there...lsearch is the cmd to find an element in a Tcl list
  if { [lsearch $mods Shelf] == -1 } {
    #puts "Shelf is NOT loaded"
  } else {
    puts "Shelf is loaded"
    set ag_tmp::shelf_loaded 1
  }
}

#############################
proc AG_Check_if_abort {} {
  if {$ag_tmp::abort == 1} {
    set ag_tmp::label1 "<B><FONT COLOR=#AA0000>Data generation process aborted"
    qsetenabled $ag_tmp::abort_button 0
  }
}

############################
proc AG_Polygon_treatment {} {
  mak cpl
  if {[gvar numpoint] < 10000} {
    poll sav nodis
    mak sortpl
  } else {
    poll sav nodis
  }
}

###############################
proc AG_Geodesywidget_get {} {
  set ag::gw_datum             [geodesywidget getdatum             $ag_tmp::geodesywidget]
  set ag::gw_coordinatesystem  [geodesywidget getcoordinatesystem  $ag_tmp::geodesywidget]
  set ag::gw_centralmeridian   [geodesywidget getcentralmeridian   $ag_tmp::geodesywidget]
  set ag::gw_originlatitude    [geodesywidget getoriginlatitude    $ag_tmp::geodesywidget]
  set ag::gw_falseeasting      [geodesywidget getfalseeasting      $ag_tmp::geodesywidget]
  set ag::gw_falsenorthing     [geodesywidget getfalsenorthing     $ag_tmp::geodesywidget]
  set ag::gw_longitudedown     [geodesywidget getlongitudedown     $ag_tmp::geodesywidget]
  set ag::gw_latitudetruescale [geodesywidget getlatitudetruescale $ag_tmp::geodesywidget]
  set ag::gw_firststdparallel  [geodesywidget getfirststdparallel  $ag_tmp::geodesywidget]
  set ag::gw_secondstdparallel [geodesywidget getsecondstdparallel $ag_tmp::geodesywidget]
  set ag::gw_utmzone           [geodesywidget getutmzone           $ag_tmp::geodesywidget]
  set ag::gw_hemisphere        [geodesywidget gethemisphere        $ag_tmp::geodesywidget]
  set ag::gw_scalefactor       [geodesywidget getscalefactor       $ag_tmp::geodesywidget]
  set ag::gw_longitudeone      [geodesywidget getlongitudeone      $ag_tmp::geodesywidget]
  set ag::gw_longitudetwo      [geodesywidget getlongitudetwo      $ag_tmp::geodesywidget]
  set ag::gw_latitudeone       [geodesywidget getlatitudeone       $ag_tmp::geodesywidget]
  set ag::gw_latitudetwo       [geodesywidget getlatitudetwo       $ag_tmp::geodesywidget]
}

###############################
proc AG_Geodesywidget_set {} {
  geodesywidget setdatum             $ag_tmp::geodesywidget $ag::gw_datum
  geodesywidget setcoordinatesystem  $ag_tmp::geodesywidget $ag::gw_coordinatesystem 
  if {$ag::gw_centralmeridian != ""} {
    geodesywidget setcentralmeridian   $ag_tmp::geodesywidget $ag::gw_centralmeridian  
  }
  if {$ag::gw_originlatitude != ""} {
    geodesywidget setoriginlatitude    $ag_tmp::geodesywidget $ag::gw_originlatitude   
  }
  if {$ag::gw_falseeasting != ""} {
    geodesywidget setfalseeasting      $ag_tmp::geodesywidget $ag::gw_falseeasting     
  }
  if {$ag::gw_falsenorthing != ""} {
    geodesywidget setfalsenorthing     $ag_tmp::geodesywidget $ag::gw_falsenorthing    
  }
  if {$ag::gw_longitudedown != ""} {
    geodesywidget setlongitudedown     $ag_tmp::geodesywidget $ag::gw_longitudedown    
  }
  if {$ag::gw_latitudetruescale != ""} {
    geodesywidget setlatitudetruescale $ag_tmp::geodesywidget $ag::gw_latitudetruescale
  }
  if {$ag::gw_firststdparallel != ""} {
    geodesywidget setfirststdparallel  $ag_tmp::geodesywidget $ag::gw_firststdparallel 
  }
  if {$ag::gw_secondstdparallel != ""} {
    geodesywidget setsecondstdparallel $ag_tmp::geodesywidget $ag::gw_secondstdparallel
  }
  if {$ag::gw_utmzone != ""} {
    geodesywidget setutmzone           $ag_tmp::geodesywidget $ag::gw_utmzone          
  }
  if {$ag::gw_hemisphere != ""} {
    geodesywidget sethemisphere        $ag_tmp::geodesywidget $ag::gw_hemisphere       
  }
  if {$ag::gw_scalefactor != ""} {
    geodesywidget setscalefactor        $ag_tmp::geodesywidget $ag::gw_scalefactor       
  }
  if {$ag::gw_longitudeone != ""} {
    geodesywidget setlongitudeone        $ag_tmp::geodesywidget $ag::gw_longitudeone       
  }
  if {$ag::gw_longitudetwo != ""} {
    geodesywidget setlongitudetwo        $ag_tmp::geodesywidget $ag::gw_longitudetwo       
  }
  if {$ag::gw_latitudeone != ""} {
    geodesywidget setlatitudeone        $ag_tmp::geodesywidget $ag::gw_latitudeone       
  }
  if {$ag::gw_latitudetwo != ""} {
    geodesywidget setlatitudetwo        $ag_tmp::geodesywidget $ag::gw_latitudetwo       
  }
}

###########################
proc AG_Build_project_button {} {
  set ag_tmp::build_prj_button [qpushbutton "Build project" {
    qprocessevents
    # --- AutoCreate a project
    if [file exists "$ag_tmp::dir/$ag::area_name/db/$ag::area_name.db"] {
      # gjr ingenting - kan ikke risikere  skrive over et prosjekt.
      # Skal man overskrive et eksisterende prosjekt - velg Tools ... et eller annet. M lages.
      qinformation "Error" "Project exists already in folder
$ag_tmp::dir/$ag::area_name/db/

To make a new project, this project must be
removed, i.e. you must manually remove this 'db'
directory with its content.
"
    } else {
      if [file exists "$ag_tmp::dir/$ag::area_name/db"] {
        # Do nothing, the db folder is still there
      } else {
        # The db-folder does not exist. I'll create it.
        file mkdir $ag_tmp::dir/$ag::area_name/db
      }
      set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Writing to project file:<BR>
      $ag_tmp::dir/$ag::area_name/db/$ag::area_name.db"
      qprocessevents
      AG_Gen_project

      set ag_tmp::label1 "<B><FONT COLOR=#0000AA>The project is written to:<BR>
      $ag_tmp::dir/$ag::area_name/db/$ag::area_name.db"
      qprocessevents
      cd ..
      qinformation "Project completed" "The project is created. Disk file: 
$ag_tmp::dir/$ag::area_name/db/$ag::area_name.db

Project name: $ag::area_name

Please note that the folder
$ag_tmp::dir/$ag::area_name/ag_files/
with all its content may now be deleted. That folder contains
temporary files used for building the project. It has been
a storage folder for data through the process of repeated runs
with the 'Generate Area' button. When the project is build with
the 'Build Project' button, it is not longer needed.
"
    }
  }]
  qsetenabled $ag_tmp::build_prj_button 1
  qsettooltip "The project should be built when the disk structure is
completed with all folders and datasets. The project will
reflect the disk structure. The button will be grey when the Area Generator is
running, generating files or if it has been aborted or stopped prematurely.
To un-grey, close and reopen the Area Generator"
}

###########################
proc  AG_Menubox_1 {} {

  if {$ag::xgeomin == ""} {set ag::xgeomin 3}
  if {$ag::xgeomax == ""} {set ag::xgeomax 10}
  if {$ag::ygeomin == ""} {set ag::ygeomin 0}
  if {$ag::ygeomax == ""} {set ag::ygeomax 5}

  qgridlayout {

    qlabel
    qlabel
    qlabel " North (Y2) "

    qnewgridline

    if {$ag_tmp::minimized == 1} {
      qpushbutton "Generate Area" {
        source $ag_tmp::path/ag_generate_area.tcl
      }
    } else {
      qlabel
    }
    qlabel
    qlineedit
    qblockedtrace ag::ygeomax
    qsetfixedsize 70 21

    qlabel
    qnewgridline

    qlabel " West (X1) "
    qlineedit
    qblockedtrace ag::xgeomin
    qsetfixedsize 70 21

    set l [qlabel]
    set pm [qpixmap $ag_tmp::path/icons/world3.png]
    qsetpixmap $l $pm

    qlineedit
    qblockedtrace ag::xgeomax
    qsetfixedsize 70 21
    qlabel " East (X2)"

    qnewgridline

    if {$ag_tmp::minimized == 1} {
      AG_Build_project_button
    } else {
      qlabel
    }
    qlabel
    qlineedit
    qblockedtrace ag::ygeomin
    qsetfixedsize 70 21

    qlabel
    set ag_tmp::abort_button [qpushbutton "Cancel run" {set ag_tmp::abort 1}]
    qsetenabled $ag_tmp::abort_button 0 

    qnewgridline
    qpushbutton "DB Query" {AG_Query}
    if {[file exists "$ag_tmp::path/haralds_pc.dummy"] == 0} {qsetenabled 0}

    qsettooltip "Experiment on using SQL-database"

    if [file exists "D:/Harald/Priv"] {
      qpushbutton "ReMacro" {
        source $ag_tmp::path/ag_procs.tcl
        set ag_tmp::label1 "ReMacroed at [clock format [clock seconds] -format {%H:%M:%S  %Z}]"
      }
    } else {
      qlabel
    }

    qlabel " South (Y1) "

    qcheckbox "Crop" {AG_Action_checkbox_crop}
    qblockedtrace ag::01_crop
    if {[file exists "$ag_tmp::path/haralds_pc.dummy"] == 0} {qsetenabled 0}
    qsettooltip "Experiment on using cropping of converted data when generating
    in order to produce a rectangular output area."

    if {$ag_tmp::minimized == 1} {
      qcheckbox "Silent mode" {AG_Set_silent_mode}
      qblockedtrace ag_tmp::silent_mode
      qsettooltip "Reduced message output"
    }
    qsetspacing 0 ;# margin in pixes between widgets
  }
}

##################
proc AG_Action_checkbox_crop {callback_var} {
  if {$callback_var == 1} {
    source $ag_tmp::path/ag_01_crop.tcl
  }
}


#####################
proc AG_Query {} {
  set query_object [qsqlquery ag_db]
  qprepare $query_object "SELECT filename FROM Countries WHERE country_name LIKE \'I%\'"
  qexecquery $query_object

  while { [qnext $query_object ] } {
    set filename [qqueryvalue $query_object 0]
    puts "Filename is $filename"
    rea $filename
    pol 3
  }
  asc
}

########################
proc AG_Minimize {} {
  qdelete $ag_tmp::main_panel
  set ag_tmp::main_panel [qmainwindow [mainwindow]]

  qsetattribute deleteonclose
  qsetwindowtitle "$ag::area_name"

  # --- Pulldowns
  set ag_tmp::minimized 1
  source $ag_tmp::path/ag_pulldowns.tcl

  qsetcentralwidget $ag_tmp::main_panel [qwidget]

  qgridlayout {
    qsetspacing 0 ;# margin in pixes between widgets
    qgroupbox "Decimal degrees, E-W 180 to -180, N-S 90 to -90" 
    AG_Menubox_1

    qnewgridline
    qgroupbox "Output Geodetics" 
    qgridlayout {
      set ag_tmp::geodesywidget [geodesywidget]
      qsetspacing 0 ;# margin in pixes between widgets
    }

    qnewgridline
    qgroupbox "" 
    qgridlayout {
      qsetspacing 0 ;# margin in pixes between widgets
      qlabel
      qblockedtrace ag_tmp::label1
    }
    qsetspacing 0 ;# margin in pixes between widgets
    set areageneratorpanel 1
  }
  qshow $ag_tmp::main_panel
}

#################################
proc AG_Stopp_klokken {} {
  # --- Klokke for hvor mye tid som er gtt
  set stop [clock seconds]

  set sec [expr $stop - $ag_tmp::starttime]
  set hour 00
  set min 00
  if {$sec > 60} {
    set min [expr int([expr $sec / 60])]
    set minsecs [expr $min * 60]
    set sec [expr $sec - $minsecs]
    if {$min > 60} {
      set hour [expr int([expr $min / 60])]
      set hourmins [expr $hour * 60]
      set min [expr $min - $hourmins]
    }
    if {$min < 10} {set min 0$min}
  }
  if {$sec < 10} {set sec 0$min}
  set ag_tmp::elapsed "${hour}:${min}:${sec}"
}

###################################
proc AG_Timestamp {comment} {
  AG_Stopp_klokken
  AG_Puts 1 "Timestamp: $ag_tmp::elapsed : $comment"
}



##################################
proc AG_Set_silent_mode {silent} {
  if {$silent == 1} {
    output messages off
  } else {
    output messages on
  }
}

################################
proc AG_Puts {lines text_string} {
  set ag::Logfile [open $ag::logfile_name a]
  if {$lines == 2} {puts $ag::Logfile ""}
  puts $ag::Logfile $text_string
  close $ag::Logfile
  if {$ag_tmp::debug == 1} {message $text_string} 
}

####################s#########
proc AG_Error_check {} {
  set ag_tmp::errorcheck 0

  if {$ag::xgeomin == ""} {
    qinformation "Area Generator Error Message" "The Geo cordinates cannot be blank"
    set ag_tmp::errorcheck 1
    return
  }
  if {$ag::xgeomax == ""} {
    qinformation "Area Generator Error Message" "The Geo cordinates cannot be blank"
    set ag_tmp::errorcheck 1
    return
  }
  if {$ag::ygeomin == ""} {
    qinformation "Area Generator Error Message" "The Geo cordinates cannot be blank"
    set ag_tmp::errorcheck 1
    return
  }
  if {$ag::ygeomax == ""} {
    qinformation "Area Generator Error Message" "The Geo cordinates cannot be blank"
    set ag_tmp::errorcheck 1
    return
  }
  if {$ag::ygeomax <= $ag::ygeomin} {
    qinformation "Area Generator Error Message" "You have not entered correct North-South coordinates.
  North coordinate is less than (or equal to) South coordinate"
    set ag_tmp::errorcheck 1
    return
  }

  if {$ag_tmp::master_data_path == "Not selected"} {
    qinformation "Area Generator Error Message" "The Master data directory is not selected. You have to select a master_data directory first!"
    set ag_tmp::errorcheck 1
    return
  }

}


####################
proc AG_Read_global_grid {grid_filename action} {

  if {[file exist $ag_tmp::master_data_path/Global_Grids/$grid_filename.vtk] == 0} {
    AG_Puts 1 "Skipped: Grid $grid_filename.vtk not found in master_data/Global_Grids/"
    if {$action == "nostore"} {
      qinformation "Error" "Error !
      File: $grid_filename.vtk
      not found in folder:
      $ag_tmp::master_data_path/Global_Grids"
      set ag_tmp::abort 1
    }
    return
  }
  set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Generating Global_Grids/$grid_filename.vtk"
  qprocessevents

  # Her m jeg sjekke om x-coord strekker seg over 180 datolinjen
  if {$ag::xgeomin < $ag::xgeomax} {
    # Strekker seg ikke over 180 datolinjen
    AG_Read_grid $grid_filename.vtk $ag::xgeomin $ag::xgeomax $ag::ygeomin $ag::ygeomax
    if {[gvar ncol] == 1} {return} ;# That is for grids like IBCAO that does not exist everywhere. Return if no data.
    if {[gvar nrow] == 1} {return} ;# That is for grids like IBCAO that does not exist everywhere. Return if no data.
    AG_Make_geotrans
  } else {
    # Strekker seg over 180 datolinjen
    AG_Read_grid $grid_filename.vtk $ag::xgeomin [expr $ag::xgeomax + 360] $ag::ygeomin $ag::ygeomax
    if {[gvar ncol] == 1} {return} ;# That is for grids like IBCAO that does not exist everywhere. Return if no data.
    if {[gvar nrow] == 1} {return} ;# That is for grids like IBCAO that does not exist everywhere. Return if no data.
    AG_Make_geotrans
  }

  if {$action != "nostore"} {
    sto Global_Grids/$grid_filename.vtk


    if {$grid_filename == "ETOPO2v2"} {mhi etopo2}
    AG_Puts 1 "Saved: Global_Grids/$grid_filename.vtk"
    set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Saved: Global_Grids/$grid_filename.vtk"
    qprocessevents
    AG_Produce_reduced $grid_filename
  }
}

###################
proc AG_Chop_to_geocoord {} {
  # Hmmm - 29. juni 2010 - skriver om til  slette punkter fr transformasjon.
  # NB! M da sjekke p at ikke alle punktene er gone.


#F.O.M 6.0.4 s ble konseptet endret slik at det rapporteres null punkter....
#  win -600 -500 -600 -500 -600 -500

  # Grrrr - umulig  vite hva som plutselig er endret i Geocap :(


  # Gjr E-W frst... (ligger i x-koord)


#  if {$ag_tmp::ppp == "glpv1_ed"} {ppp}
  swi zyx
  eli lt $ag::xgeomin
  if {$ag_tmp::passes_dateline == 0} {
    eli gt $ag::xgeomax
  } else {
    eli gt [expr $ag::xgeomax + 360]
  }

  swi zyx

  # S N-S
  swi xzy
  eli lt $ag::ygeomin
  eli gt $ag::ygeomax
  swi xzy

  # Grrrr - utrolig irriterende at nr alle punkter er vekke legges det inn to dummy-punkter i
  # vindusrammen slik at jeg m gjre en tpelig test a'la denne.

  #Kriselsning lagt inn i 6.0.5.... etter at Olav endret konseptet.
  set ag_tmp::empty 0
  if {[gvar numpoint] == 0} {set ag_tmp::empty 1}
#  if {[gvar zmin] == -600} {set ag_tmp::empty 1}
#  if {[gvar ymin] == -600} {set ag_tmp::empty 1}
#  if {[gvar xmin] == -600} {set ag_tmp::empty 1}
}

###################
proc AG_Create_global_point {name} {

#puts "Global point: $name"

  set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Creating global points ($name) ..."
  qprocessevents
  rea $ag_tmp::master_data_path/Global_Point_DB/$name.vtk

#set ag_tmp::ppp $name

  AG_Chop_to_geocoord

  # hvis isgrid == 99 s er alle punkter slettet. Blh - for en test. 
#puts "Name: $name isgid [gvar isgrid] numpoint [gvar numpoint]"

  if {[gvar isgrid] != 99 && [gvar numpoint] > 0} {
    AG_Make_geotrans
    ssc h etopo2
    eli owi
    spe mar 9
    poi
    if {$name == "GEBCO_Feature_Names"} {
      if {[gvar numpoint] != 0.0} {
        zap etopo2
        sub 100
      }
    }
    sto Global_Point_DB/$name.vtk
    AG_Puts 1 "Saved: Global_Point_DB/$name.vtk"
  } else {
    AG_Puts 1 "Skipped, no points: Global_Point_DB/$name.vtk"
  }
}

###################
proc AG_Goto_projecttop {} {
  # Make root current object
  project activate / "00. Area Generator Data"
}

#######################
proc AG_Find_dirs_recursively {} {
  #set dirs [glob -nocomplain -types d -directory "$ag_tmp::dir/$ag::area_name/ag_files" *]
  set dirs [glob -nocomplain -types d -directory [pwd] *]
  foreach dir $dirs {
    project create category_generic [file tail $dir]
    #cd [file tail $dir]
    cd $dir
    set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Writing to project file, please wait...<BR>
    $ag_tmp::dir/$ag::area_name/db/$ag::area_name.db<BR>
    $dir"
    qprocessevents

    set filelist [glob -nocomplain ./*.vtk]
    foreach vtk $filelist {
      rea $vtk
      set name [file rootname [file tail $vtk]]
      set type "vtk_poly_data"
      if {[gvar isgrid] == 1} {
        set type "vtk_structured_points"
      }
      project create $type $name
      ##AG_Puts 1 "project setvtkfile $ag_tmp::dir/$ag::area_name/$path/$name.vtk"
      project setdata 

      geo lowerproject  ;# Nytt 10.Mars.2009. Setter riktig projeksjon til prosjektet under bygging.


      if {$ag_tmp::shelf_loaded == 1} {
        # set schema
        if {[file tail [pwd]] == "gshhs"} {
          project setschema "Coast Line"
        } elseif {[string match -nocase "*coast*" $name]} {
          project setschema "Coast Line"
        } elseif {[string match -nocase "*wvsplus*" $name]} {
          project setschema "Coast Line"
        } elseif {[string match -nocase "sedthick*" $name]} {
          project setschema "Sediment Thickness"
        } elseif {[string match -nocase "sedbase*" $name]} {
          # do nothing
        } elseif {[string match -nocase "Seabed_Norway*" $name]} {
          project setschema "Seabed Surface"
        } elseif {[string match -nocase "kms*" $name]} {
          # do nothing
        } elseif {[string match -nocase "*ravity*" $name]} {
          # do nothing
        } elseif {[string match -nocase "wdmam*" $name]} {
          # do nothing
        } elseif {[string match -nocase "EMAG*" $name]} {
          # do nothing
        } elseif {[file tail [pwd]] == "Global_Grids"} {
          project setschema "Seabed Surface"
        } elseif {[string match -nocase "*bathym*" [file tail [pwd]]]} {
          if {[string match -nocase "*multi*" [file tail [pwd]]]} {
            # do nothing
          } elseif {[string match -nocase "*time*" [file tail [pwd]]]} {
            # do nothing
          } else {
            project setschema "Bathymetric Profile"
          }
        }
      }
      project up
    }

    AG_Find_dirs_recursively
    cd ..
    project up
  }
}

#######################
proc AG_Gen_project {} {
  # Create project
  #project new "C:/Documents and Settings/Anders/My Documents/pdir/p.db"
  project new "$ag_tmp::dir/$ag::area_name/db/$ag::area_name.db" "$ag::area_name"
  project activate
  project create category_generic "00. Area Generator Data"

  cd "$ag_tmp::dir/$ag::area_name/ag_files"
  geodesywidget setaslower $ag_tmp::geodesywidget ;# Nytt 12. Aug. 2009

  AG_Find_dirs_recursively

  AG_Goto_projecttop

  project save
  #project close
}

#######################
proc AG_View_file {file title} {
  set t [open $file r]
  set contents [read $t] ; # contents is now a variable containing
  close $t

  # ----------------------#
  # ---- Start panel ---- #
  # ----------------------#
  set w [qwidget]
  qsetattribute deleteonclose
  qsetwindowtitle "$title"

  qgridlayout {
    qtextedit
    qsettext "$contents"
    qsetproperty minimumWidth 450
    qsetproperty minimumHeight 600
    #qsetpaper 255 255 210
  }
  #qsetpaper 1 1 .7
  qshow $w
}

########################
proc AG_My_save_a_file { filter } {
  set filename [qsavefilename $filter ]
  set ag_tmp::filename $filename
}

###########################
proc AG_My_open_a_agfile { filter } {
  set filename [qopenfilename $filter]
  set ag_tmp::filename $filename
}

###########################
proc AG_My_open_a_agdir {directory} {
  set ag_tmp::dirname [qexistingdir [pwd]]
  set dirname [file tail $ag_tmp::dirname]
  if {$ag_tmp::dirname == ""} {
    # Cancel button selected - do nothing 
    return
  } 

  if {$directory == "area"} {
    if {$dirname != "area" && $dirname != "Area"} {
      set ag_tmp::dir "Not selected"
      cd $ag_tmp::dirname
      qprocessevents
      qwarning "Warning" "The directory must be named <b>area</b> or <b>Area</b>.
      No other directory names are accepted by this program
      Please Browse again to select Area root directory"
    } else {
      set ag_tmp::dir $ag_tmp::dirname
      cd $ag_tmp::dirname
    }
  } else {
    if {$dirname != "master_data"} {
      set ag_tmp::master_data_path "Not selected"
      qprocessevents
      qwarning "Warning" "The directory must be named <b>master_data</b>
      No other directory name is accepted by this program
      Please Browse again to select the master data directory"
    } else {
      set ag_tmp::master_data_path $ag_tmp::dirname
    }
  }
}

##############################
proc AG_Gen_lines {maindir VTK_dir MinMax_dir newput_dir oppsamling topology} {
  # mainwindow open test.html
  # bruk qtextedit toplevel ... for  f dette inn... som et "flytende" vindu.

  set x1 $ag::xgeomin
  set x2 $ag::xgeomax
  set y1 $ag::ygeomin
  set y2 $ag::ygeomax

  set filelist [glob $MinMax_dir/*.vtk]
  set noof_elements [llength $filelist]
  set files_written 0
  set files_read 0
  dhi oppsamling
  foreach vtk $filelist {
    AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}
    rea $vtk

    if {$ag_tmp::debug == 1} {AG_Puts 1 "Debug Read: $vtk"}
    incr files_read
    set px1 [gvar xmin]
    set px2 [gvar xmax]
    set py1 [gvar ymin]
    set py2 [gvar ymax]
    set rejected 0
    if {$ag_tmp::silent_mode == 0} {
      set ag_tmp::label1 "
<B><FONT COLOR=#0000AA>$newput_dir File: <FONT COLOR=#880000>[file tail $vtk]
<BR><FONT COLOR=#0000AA>Datasets read: $files_read of $noof_elements Datasets written: $files_written
<BR>Xmin: $px1 Xmax: $px2
<BR>Ymin: $py1 Ymax: $py2"
      qprocessevents
    }


    set ag_tmp::passes_dateline 0
    if {$ag::xgeomin > $ag::xgeomax} {
      # antar dette bare skjer over 180 datolinjen
      set ag_tmp::passes_dateline 1
      if {$px2 < $x1 && $px1 > $x2} {
        set rejected 1
      }
    } else {
      if {$px2 < $x1} {
        set rejected 1
      } elseif {$px1 > $x2} {
        set rejected 1
      }
    }

    if {$py2 < $y1} {
      set rejected 1
    } elseif {$py1 > $y2} {
      set rejected 1
    }


    if {$rejected == 1} {
      # do nothing
    } else {
      set ag_tmp::label1 "
<B><FONT COLOR=#0000AA>$newput_dir File: <FONT COLOR=#880000>[file tail $vtk] passed
<BR><FONT COLOR=#0000AA>Datasets read: $files_read of $noof_elements Datasets written: $files_written
<BR>Xmin: $px1 Xmax: $px2
<BR>Ymin: $py1 Ymax: $py2"
      qprocessevents

      set filename [file tail $vtk]
      rea $VTK_dir/$filename

      if {$topology == "polygons"} {
        AG_Polygon_treatment
      }

      # Legger inn en r sletting av alt som er utenfor jorden. Litt tvilsomt
      win -180 180 -90 90 0 100 
      eli owi

      # Her m jeg flytte den negative biten dersom det er over datolinjen

      # --- Dette er et problem - fikser jeg dette??????????????????
      if {$ag_tmp::passes_dateline == 1} {
        swi zyx
        if {[gvar zmax] < 0} {
          # alle data ligger negativt omrde, st for datolinjen
          add 360
        } elseif {[gvar zmin] > 0} {
          # alle data ligger positivt omrde, vest for datolinjen
        } else {
          # m splitte datasettet i to og legge til 360 p negativ side
          mhi tmp_11
          eli lt 0
          mhi tmp_positive
          mlo tmp_11
          eli gt 0
          add 360
          mlo tmp_positive app
          dhi tmp_11
          dhi tmp_positive
        }
        swi zyx
      }

      if {$maindir == "BGR" && $ag::create_bgr == "Create inside window"} {AG_Chop_to_geocoord}
      if {$maindir == "BSH" && $ag::create_bsh == "Create inside window"} {AG_Chop_to_geocoord}
      if {$maindir == "GA_GOV_AU" && $ag::create_ga_gov_au == "Create inside window"} {AG_Chop_to_geocoord}
      if {$maindir == "Geodas" && $ag::create_geodas == "Create inside window"} {AG_Chop_to_geocoord}
      if {$maindir == "GMBD" && $ag::create_gmbd == "Create inside window"} {AG_Chop_to_geocoord}
      if {$maindir == "Ifremer" && $ag::create_ifremer == "Create inside window"} {AG_Chop_to_geocoord}
      if {$maindir == "Industry" && $ag::create_industry == "Create inside window"} {AG_Chop_to_geocoord}
      if {$maindir == "IPGS" && $ag::create_ipgs == "Create inside window"} {AG_Chop_to_geocoord}
      if {$maindir == "JAMSTEC" && $ag::create_jamstec == "Create inside window"} {AG_Chop_to_geocoord}
      if {$maindir == "JODC" && $ag::create_jodc == "Create inside window"} {AG_Chop_to_geocoord}
      if {$maindir == "MG_DMS" && $ag::create_mg_dms == "Create inside window"} {AG_Chop_to_geocoord}
      if {$maindir == "Scripps" && $ag::create_scripps == "Create inside window"} {AG_Chop_to_geocoord}
      if {$maindir == "Norway"} {AG_Chop_to_geocoord}
      if {$maindir == "SeaDOG" && $ag::create_seadog == "Create inside window"} {AG_Chop_to_geocoord}
      if {$maindir == "UTIG" && $ag::create_utig == "Create inside window"} {AG_Chop_to_geocoord}
      if {$maindir == "USGS" && $ag::create_usgs == "Create inside window"} {AG_Chop_to_geocoord}
      if {$maindir == "WHOI" && $ag::create_whoi == "Create inside window"} {AG_Chop_to_geocoord}
      if {$maindir == "ECS" && $ag::create_ecs == "Create inside window"} {AG_Chop_to_geocoord}
      # Kan ikke sjekke p maindir, for det ligger under $maindir=Coastline
      if {$VTK_dir == "$ag_tmp::master_data_path/Coastline/wvsplus/wvsplus_VTK" && $ag::create_wvsplus == "Create inside window"} {
        AG_Chop_to_geocoord
      }
      if {$maindir == "UN_Boundaries_01" && $ag::create_un_boundaries_01 == "Create inside window"} {AG_Chop_to_geocoord}

      if {$ag_tmp::empty == 1} {
        # Do nothing
      } else {
        # Legger inn noen sjekker her p om Data lar seg konvertere
        if {[geodesywidget getcoordinatesystem $ag_tmp::geodesywidget] == "Polar Stereographic" } {
          # m legge inn denne testen, for at surveys som krysser ekvator skal bli klippet vekk p
          # feil side av ekvator. Nytt 5. oktober 2006
          # Det kan vre en viss fare i at (nesten) alle punkter slettes, men jeg tror ikke det.

          if {[geodesywidget getlatitudetruescale $ag_tmp::geodesywidget] > 0} {
            win -181 181 10 91 0 100 
            eli owi
          } else {
            win -181 181 -91 -10 0 100 
            eli owi
          }
          ssc h etopo2
        }
        if {[geodesywidget getcoordinatesystem $ag_tmp::geodesywidget] == "Mercator"} {
          if {[gvar ymax] > 89.49} {
            if {[gvar ymax] > 90.001} {
              qinformation "Error" "Error in input to geodetic conversion to mercator.
              Mercator projection is not valid for latitude values >= 90
              File: $VTK_dir/$filename"
            } else {
              # Har trolig sttt p verdien 90
              swi xzy
              set value [gvar zmax]
              eli gt 89.5
              set v2 [gvar zmax]
              swi xzy

              AG_Puts 2 "File: $VTK_dir/$filename"
              AG_Puts 1 "  Mercator Warning: This file has latitude values (max=$value)"
              AG_Puts 1 "  greater than 89, values > 89.5 are removed. (max=$v2)"
            }
          }
          if {[gvar ymin] < -89.49} {
            if {[gvar ymax] < -90.001} {
              qinformation "Error" "Error in input to geodetic conversion to mercator.
              Mercator projection is not valid for latitude values <= -90
              File: $VTK_dir/$filename"
            } else {
              # Har trolig sttt p verdien 90
              swi xzy
              set value [gvar zmin]
              eli lt -89.5
              set v2 [gvar zmin]
              swi xzy

              AG_Puts 2 "File: $VTK_dir/$filename"
              AG_Puts 1 "  Mercator Warning: This file has latitude values (min=$value)"
              AG_Puts 1 "  less than -89, values < -89.5 are removed. (min=$v2)"
            }
          }
        }
      }

      if {[gvar isgrid] == 99 || [gvar numpoint] == 0 || $ag_tmp::empty == 1} {
        AG_Puts 2 "Outside area: $VTK_dir/$filename isgrid=[gvar isgrid] Numpoint=[gvar numpoint]"
        # Alle punkter ligger utenfor omrdet...
      } else {
        AG_Make_geotrans
        set f [file tail $vtk]
        set f2 [file rootname $f]
        if {$topology == "lines"} {
          mak lin ;# linjedata kommer inn bare som punkter.... 

          if {[geodesywidget getcoordinatesystem $ag_tmp::geodesywidget] == "Geodetic" } {
            mak cel dis 0.05
          } else {
            # Dette er en kritisk operasjon. Her sier jeg egentlig at dersom gapet til
            # neste punkt er strre enn 5000m klippes linjen.
            mak cel dis 5000
          }
        }

# her sto eli owi setninger tidligere....

        # hvis isgrid == 99 s er alle punkter slettet. Blh - for en test. 
        if {[gvar isgrid] != 99 && [gvar numpoint] > 0} {
          if {$oppsamling == "collect" && $ag::skip_accumulating == 0} {
            # bare p collect - s blir ikke multibeam forskt sortert...
            # 13.Nov.2007 kommenterer vekk mak sortpl - fordi den trolig snur linjer. Ikke bra.
            #mak sortpl ;# fant ut at store surveyer trenger sortering
            #mak sca
          }
          # Lagres lokalt i prosjektet... 
          if {$topology == "freepoints"} {
            mak pts
          }
          if {$maindir != "Norway"} {
            # Ingen lagring for Norway land og sea
            sto $newput_dir/${f2}.vtk
          }
          AG_Puts 1 "Saved $files_written : $newput_dir/${f2}.vtk"
          if {$oppsamling == "collect"  && $ag::skip_accumulating == 0} {
            if {$files_written == 0} {
              mhi oppsamling
            } else {
              mhi oppsamling app
            }
          }
          incr files_written
        }
        ###set htmlfile "$f.html"
        ###message "html: $htmlfile"
        ###mainwindow open $htmlfile
        # - skal lese alle andre datamaindirr:
      }
    }
  }
  AG_Puts 1 "AG: $maindir No. of datasets written: $files_written $newput_dir"
  if {$oppsamling == "collect" && $ag::skip_accumulating == 0} {
    if {$files_written >= 2} {
      mlo oppsamling
      if {[gvar numpoint] > 2} {
        if {$maindir == "Norway"} {
          ssc
          if {$ag_tmp::norway == "sea"} {
            ssc
	    if {$newput_dir == "Norway/Dybdedata50m"} {
              set tmpinc 200
              son ppg inc $tmpinc $tmpinc eig
              eli lt 0 0
              sto $newput_dir/Seabed_Norway_inc$tmpinc.vtk
            } else {
              set tmpinc 25
              son ppg inc $tmpinc $tmpinc all
              sto $newput_dir/Seabed_Norway_inc$tmpinc.vtk
            }
	  } else {
            # land
            ssc
            set tmpinc 10
            son ppg inc $tmpinc $tmpinc all
            sto $newput_dir/Land_Norway_inc$tmpinc.vtk          
          }
        } else {
          sto $newput_dir/00_all.vtk
          AG_Puts 1 "Saved: $newput_dir/00_all.vtk Files written: $files_written"
        }
      }
    }
  }
}

##############################
proc AG_Read_grid {grid x1 x2 y1 y2} {
  set tmppath [qtemppath]
  #set f "C:/Program Files/00_HSund/Geocap/grid2vtk.exe"
  set f $ag_tmp::grid2vtk_located

  if [file exists $f] {
    exec $f -n $y2 -s $y1 -e $x2 -w $x1 $ag_tmp::master_data_path/Global_Grids/$grid $tmppath/tmp_geocapgrid.vtk
  } else {
    exec $ag_tmp::path/progs/grid2vtk.exe -n $y2 -s $y1 -e $x2 -w $x1 $ag_tmp::master_data_path/Global_Grids/$grid $tmppath/tmp_geocapgrid.vtk
  }
  rea $tmppath/tmp_geocapgrid.vtk

  file delete -force $tmppath/tmp_geocapgrid.vtk
}

##############################
proc AG_Gen_coastline {letter} {
  set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Generating coastline $letter ..."
  qprocessevents
  # Her m jeg sjekke om x-coord strekker seg over 180 datolinjen
  if {$ag::xgeomin > $ag::xgeomax} {
    # antar dette bare skjer over 180 datolinjen
###    rea auto xmin $ag::xgeomin xmax 180 ymin $ag::ygeomin ymax $ag::ygeomax\
###    $ag_tmp::master_data_path/Coastline/gshhs/gshhs_$letter.b
###    AG_Make_geotrans
###    mak fre x
###    mhi del1
###
###    rea auto xmin -180 xmax $ag::xgeomax ymin $ag::ygeomin ymax $ag::ygeomax\
###    $ag_tmp::master_data_path/Coastline/gshhs/gshhs_$letter.b
###    AG_Make_geotrans
###    mlo del1 app
###    dhi del1
###    mhi del1 ;# workaround
###
### --- Kuttet ut det ovenstende 24/11 2011 ifbm. 180graders opprydningen.

    rea auto xmin $ag::xgeomin xmax [expr $ag::xgeomax + 360]  ymin $ag::ygeomin ymax $ag::ygeomax\
    $ag_tmp::master_data_path/Coastline/gshhs/gshhs_$letter.b
if {$letter == "c"} {
 puts "Numpoint [gvar numpoint] gshhs_$letter.b"
}

  } else {
    rea auto xmin $ag::xgeomin xmax $ag::xgeomax ymin $ag::ygeomin ymax $ag::ygeomax\
    $ag_tmp::master_data_path/Coastline/gshhs/gshhs_$letter.b
  }
  AG_Make_geotrans
  
  if {[gvar numpoint] > 4} {
    # ... ellers har jeg ingen kyst i omrdet...

    if {$ag::skip_sorting_coast == 1 && $letter == "f"} {
      # da dropper jeg sorteringen, for det blir for stort
    } else {
      set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Sorting coastline $letter ..."
      qprocessevents
      AG_Puts 2  "Debug: punkter foer  mak sortpl coast $letter: [gvar numpoint]"
      mak sortpl
      AG_Puts 1 "Debug: punkter etter mak sortpl coast $letter: [gvar numpoint]"
    }

    #zap etopo2 ;# Dropper denne - beholder verdiene jeg har p input...
    #eli lt -300
    eli gt 0 0
    if {$letter == "f"} {
#      set file "Coastline/gshhs/coastline.vtk"
      set file "Coastline/gshhs/gshhs_$letter.vtk"
      sto $file
      AG_Puts 1 "Saved: $file"
      if {[geodesywidget getcoordinatesystem $ag_tmp::geodesywidget] == "Geodetic" } {
        # dette virker ikke i pre 4.0 releaser - kanskje etter???
        # nsker  kutte ut punkter uten  miste detaljer p yer ...
        del cel nr gt 4
        mhi islands
        AG_Puts 1  "AG: Test-coast: Islands: points: [gvar numpoint] cells: [gvar numcell]"
        rea $file
        del cel nr lt 5
        AG_Puts 1  "AG: Test-coast: Main: points: [gvar numpoint] cells: [gvar numcell]"
        #mak lin dis 5000; dette virker ikke - mange celler slettes helt.
        mhi tmp
        set no_of_cells [gvar numcell]
        if {$ag::use_lines_in_testcoast == 0} {
          mak poi sel 10
          mak clean
          mhi coast
          AG_Puts 1  "AG: Test-coast: Main: points: [gvar numpoint] after reduction"
        } else {
          set i 0
          while {$i < $no_of_cells} {
            mlo tmp
            mak cel $i
            mak poi sel 10
            mak clean
            mak lin
            if {$i == 0} {mhi coast}
            if {$i > 0} {
              mlo coast app
              dhi coast
              mhi coast
            }
            if {$i == 100} {AG_Puts 1 "   Completed $i coast cells out of $no_of_cells ....."}
            if {$i == 200} {AG_Puts 1  "   Completed $i coast cells out of $no_of_cells ....."}
            if {$i == 300} {AG_Puts 1  "   Completed $i coast cells out of $no_of_cells ....."}
            if {$i == 400} {AG_Puts 1  "   Completed $i coast cells out of $no_of_cells ....."}
            if {$i == 500} {AG_Puts 1  "   Completed $i coast cells out of $no_of_cells ....."}
            if {$i == 600} {AG_Puts 1  "   Completed $i coast cells out of $no_of_cells ....."}
            if {$i == 700} {AG_Puts 1  "   Completed $i coast cells out of $no_of_cells ....."}
            if {$i == 800} {AG_Puts 1  "   Completed $i coast cells out of $no_of_cells ....."}
            if {$i == 900} {AG_Puts 1  "   Completed $i coast cells out of $no_of_cells ....."}
            if {$i == 1000} {AG_Puts 1  "   Completed $i coast cells out of $no_of_cells ....."}
            if {$i == 1000} {AG_Puts 1  "   end of listing, process continues ..."}
            incr i
          }
          dhi tmp
        }
        mlo coast
        AG_Puts 1 "AG: Test-coast: Main-reduced: points: [gvar numpoint] cells: [gvar numcell]"
        mlo islands app

        set file "Coastline/gshhs/coastline_test.vtk"
        sto $file
        AG_Puts 1 "Saved: $file"
      # nsker  kutte ut endel punkter uten  miste yer ...
#    del cel gt 25
#    mhi islands
#    rea AG_files/coastline_cm${ag::central_mer}.vtk
#    del cel nr lt 26
#    mlo islands app

        mak lin dis 5000
      } else { 
        # hmmmm - ser ut som oom jeg har tabbet meg ut her.
        # tror denne skal g dersom == "Geodetic". Sjekk !!!!
        #mak cel dis 0.05
      }

    } elseif {$letter == "h"} {
#      set file "Coastline/gshhs/coastline_s.vtk"
       set file "Coastline/gshhs/gshhs_$letter.vtk"
       sto $file
       AG_Puts 1 "Saved: $file"
    } elseif {$letter == "i"} {
#      set file "Coastline/gshhs/coastline_xs.vtk"
       set file "Coastline/gshhs/gshhs_$letter.vtk"
       sto $file
       AG_Puts 1 "Saved: $file"
    } elseif {$letter == "l"} {
#      set file "Coastline/gshhs/coastline_xxs.vtk" 
      set file "Coastline/gshhs/gshhs_$letter.vtk"
      sto $file
      AG_Puts 1 "Saved: $file"
    } elseif {$letter == "c"} {
#      set file "Coastline/gshhs/coastline_xxxs.vtk"
      set file "Coastline/gshhs/gshhs_$letter.vtk"
      sto $file
      AG_Puts 1 "Saved: $file"
    }
  }
  dhi islands
  dhi coast
  dhi tmp
  dhi del1
  dhi ^*
}

##################################
proc AG_Produce_reduced {grid_filename} {
  mhi tmp
  mlo etopo2
  ssc
  set nrow [gvar nrow]
  set ncol [gvar ncol]
  set xinc [gvar xinc]
  set yinc [gvar yinc]

  # Mtte legge inn (16/2-2012) en sjekk p om sedimentgriddet kun var udef - da feilet AG...
  set ag_tmp::skipsedthick 0


  # --- 2 min, likt etopo2
  if {$grid_filename == "ETOPO2v2"} {
    # do nothing
  } else {
    mlo tmp
    grp $nrow $ncol
    sto Global_Grids/${grid_filename}_02min.vtk
    AG_Puts 1 "Saved: Global_Grids/${grid_filename}_02min.vtk"
    set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Saved: Global_Grids/${grid_filename}_02min.vtk"
    qprocessevents
    if {$grid_filename == "sedthick_world"} {
      if {[gvar data] == 0} {set ag_tmp::skipsedthick 1}
      if {$ag_tmp::skipsedthick == 0} {
        add lo etopo2
        sto Global_Grids/sedbase_world_02min.vtk
        mhi base
        AG_Puts 1 "Saved: Global_Grids/sedbase_world_02min.vtk"
        set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Saved: Global_Grids/sedbase_world_02min.vtk"
      }
      qprocessevents
    }
  }


  # --- 5 minutters grid
  mlo tmp
  set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Creating etopo2-data 05min ..."
  grp inc [expr $xinc * 2.5] [expr $yinc * 2.5]

  sto Global_Grids/${grid_filename}_05min.vtk
  AG_Puts 1 "Saved: Global_Grids/${grid_filename}_05min.vtk"
  set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Saved: Global_Grids/${grid_filename}_05min.vtk"

  qprocessevents


  if {$grid_filename == "ETOPO2v2"} {
    set ag_tmp::coarsenrow [expr [gvar nrow] + 25]
    set ag_tmp::coarsencol [expr [gvar ncol] + 25]
    if {$ag_tmp::coarsenrow > 500} {set ag_tmp::coarsenrow 500}
    if {$ag_tmp::coarsencol > 500} {set ag_tmp::coarsencol 500}

    # --- 10 minutters ETOPO grid
    mlo tmp
    set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Creating etopo2-data 10min ..."
    grp inc [expr $xinc * 5] [expr $yinc * 5]

    sto Global_Grids/${grid_filename}_10min.vtk
    AG_Puts 1 "Saved: Global_Grids/${grid_filename}_10min.vtk"
    set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Saved: Global_Grids/ETOPO2v2_10min.vtk"
    qprocessevents
  }

  dhi tmp
  mlo etopo2
  ssc
}

############################
proc AG_Read_and_convert_lines {name pathtype topology} {
  set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Creating $name ..."
  qprocessevents
  # Her m jeg sjekke om x-coord strekker seg over 180 datolinjen
  if {$ag::xgeomin > $ag::xgeomax} {
    # antar dette bare skjer over 180 datolinjen
    # Mulig at denne operasjonen er undvendig for kyst og andre data
    # som ikke lappes sammen. Tror det er OK  kjre uten denne todelingen.

    dhi del1

    if {$pathtype == "relative_path"} {
      rea $ag_tmp::master_data_path/$name
    } else {
      rea $name
    }
    if {$topology == "polygon"} {AG_Polygon_treatment}

    win $ag::xgeomin 180 $ag::ygeomin $ag::ygeomax -10 10
    eli owi

    set hi_del1_exists 0
    if {[gvar numpoint] != 0} {
      AG_Make_geotrans
      mhi del1
      set hi_del1_exists 1
    }

    if {$pathtype == "relative_path"} {
      rea $ag_tmp::master_data_path/$name
    } else {
      rea $name
    }
    if {$topology == "polygon"} {AG_Polygon_treatment}

    win -180 $ag::xgeomax $ag::ygeomin $ag::ygeomax -10 10
    eli owi
    if {[gvar numpoint] != 0} {
      AG_Make_geotrans
      if {$hi_del1_exists == 1} {
        mlo del1 app
      }
    } else {
      if {$hi_del1_exists == 1} {mlo del1}
    }

    dhi del1
    mhi del1 ;# workaround

  } else {
    if {$pathtype == "relative_path"} {
      rea $ag_tmp::master_data_path/$name
    } else {
      rea $name
    }
    if {$topology == "polygon"} {AG_Polygon_treatment}

    win $ag::xgeomin $ag::xgeomax $ag::ygeomin $ag::ygeomax -10 10
    eli owi
    AG_Make_geotrans
  }
}

#################
###proc AG_Spin_through {type container} {
###  set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Creating $type-data ..."
###  qprocessevents
###
###  # hanker inn alle foldernavn fra master data
###  set folderlist [glob $ag_tmp::master_data_path/$type/${type}_MinMax/*]
###  foreach folder $folderlist {
###    set foldername [file tail $folder]
###    file mkdir $type/$foldername
###  }
###
###  AG_Gen_lines Track_Line $type normal
###  foreach folder $folderlist {
###    set foldername [file tail $folder]
###    if {$ag::only_tracklines != 1 && $folder != "Track_Line"} {
###      AG_Gen_lines $foldername $type normal
###    }
###  }
###}

#################
proc AG_Spin_through {maindir subdir splitname organized_as oppsamling topology} {
  # $maindir      => BGR, BSH, Geodas, Ifremer, ...
  # $subdir       => no_subdir, MultiBeam
  # $splitname    => Geodas, Bathymetry, KAIREI_Tokyo_Datum
  # $organised_as => folders, data
  # $oppsamling   => collect, nocollect
  # $topology     => keepstructure, lines, polygons

  #AG_Spin_through BSH no_subdir BSH_Multibeam folders nocollect keepstructure

  # denne prosedyren finner fram til alle relevante foldere og oppretter dem p disk.
  # s kalles AG_Gen_lines for  generere alle linjene i en folder.

#maindir     : UTIG
#subdir      : no_subdir
#splitname   : UTIG
#organized as: folders
#oppsamling  : collect
#topology    : keepstructure

  if {$subdir == "no_subdir"} {
    set masterdata_dir $ag_tmp::master_data_path/$maindir/$splitname
    set put_dir $maindir
    if {$organized_as == "folders"} {
      if {$splitname != $maindir} {
        set put_dir $maindir/$splitname
        file mkdir $put_dir
        AG_Puts 1 "Made dir: $put_dir"
      }
    }
  } else {
    set masterdata_dir $ag_tmp::master_data_path/$maindir/$subdir/$splitname
    set put_dir $maindir/$subdir
    file mkdir $put_dir
    AG_Puts 1 "Made dir: $put_dir"
    if {$organized_as == "folders"} {
      set put_dir $put_dir/$splitname/
      file mkdir $put_dir
      AG_Puts 1 "Made dir: $put_dir"
    }
  }

  if {[file exists "${masterdata_dir}_MinMax"] == 0} {
    set ag_tmp::abort 1
    qinformation "Error in Area Generator" "The folder
    ${masterdata_dir}_MinMax
    Does not exist ! Check your Master data"
    return
  }

  set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Creating $put_dir $splitname $organized_as"
  qprocessevents

  # hanker inn alle foldernavn fra aktuell folder:
  if {$organized_as == "folders"} {
    set dirs [glob -nocomplain -types d -directory ${masterdata_dir}_MinMax *]
    if {$ag_tmp::debug == 1} {AG_Puts 1 "Debug: Search folder ${masterdata_dir}_MinMax]"}

    foreach dir $dirs {
      set dirname [file tail $dir]
      if {$ag_tmp::debug == 1} {AG_Puts 1 "Debug: Search subfolder ${masterdata_dir}_MinMax/$dir]"}

      set MinMax_dir ${masterdata_dir}_MinMax/$dirname
      set VTK_dir ${masterdata_dir}_VTK/$dirname

      set newput_dir $put_dir/$dirname
      file mkdir $newput_dir
      AG_Puts 1 "Made dir: $newput_dir"
      AG_Gen_lines $maindir $VTK_dir $MinMax_dir $newput_dir $oppsamling $topology
    }
  } else {
    set newput_dir $put_dir/$splitname 
    file mkdir "$newput_dir"
    AG_Puts 1 "Made dir: $newput_dir"
    set MinMax_dir ${masterdata_dir}_MinMax
    set VTK_dir ${masterdata_dir}_VTK
    AG_Gen_lines $maindir $VTK_dir $MinMax_dir $newput_dir $oppsamling $topology
  }
  mlo etopo2
  dhi ^*
  dhi *
  mhi etopo2
}

#################################
proc AG_Dir_is_empty { path } {
  set contents [glob -nocomplain -directory $path *]
  if { $contents == "" } {
    return true;
  } else {
    return false;
  }
}

################################################
proc AG_Delete_empty_subfolders_recursively {path} {
  # Not empty - Get all directories
  set dirs [glob -nocomplain -types d -directory $path *]
  foreach dir $dirs {
    AG_Delete_empty_subfolders_recursively $dir
  }
  if { [AG_Dir_is_empty $path] } {
    set ag_tmp::label1 "<B><FONT COLOR=#0000AA>$path
    <BR>Directory is empty, deleting ..."
    qprocessevents
    puts "$path is empty, deleting"
    file delete -force $path
    return
  }
}

########################################
proc AG_Set_Nonexisting_2_Skip {} {
  if {[file exist $ag_tmp::master_data_path/BGR] == 0}       {set ag::create_bgr "Skip"}
  if {[file exist $ag_tmp::master_data_path/BSH] == 0}       {set ag::create_bsh "Skip"}
  if {[file exist $ag_tmp::master_data_path/GA_GOV_AU] == 0} {set ag::create_ga_gov_au "Skip"}
  if {[file exist $ag_tmp::master_data_path/Geodas] == 0}    {set ag::create_geodas "Skip"}
  if {[file exist $ag_tmp::master_data_path/GMBD] == 0}      {set ag::create_gmbd "Skip"}
  if {[file exist $ag_tmp::master_data_path/Ifremer] == 0}   {set ag::create_ifremer "Skip"}
  if {[file exist $ag_tmp::master_data_path/IPGS] == 0}      {set ag::create_ipgs "Skip"}
  if {[file exist $ag_tmp::master_data_path/JAMSTEC] == 0}   {set ag::create_jamstec "Skip"}
  if {[file exist $ag_tmp::master_data_path/JODC] == 0}      {set ag::create_jodc "Skip"}
  if {[file exist $ag_tmp::master_data_path/MG_DMS] == 0}    {set ag::create_mg_dms "Skip"}
  if {[file exist $ag_tmp::master_data_path/SeaDOG] == 0}    {set ag::create_seadog "Skip"}
  if {[file exist $ag_tmp::master_data_path/Scripps] == 0}   {set ag::create_scripps "Skip"}
  if {[file exist $ag_tmp::master_data_path/Norway] == 0}    {set ag::create_norway_sea "Skip"}
  if {[file exist $ag_tmp::master_data_path/Norway] == 0}    {set ag::create_norway_land "Skip"}
  if {[file exist $ag_tmp::master_data_path/ECS] == 0}       {set ag::create_ecs "Skip"}
  if {[file exist $ag_tmp::master_data_path/USGS] == 0}       {set ag::create_usgs "Skip"}
  if {[file exist $ag_tmp::master_data_path/UN_Boundaries_01] == 0} {set ag::create_un_boundaries_01 "Skip"}
  if {[file exist $ag_tmp::master_data_path/UTIG] == 0}      {set ag::create_utig "Skip"}
  if {[file exist $ag_tmp::master_data_path/WHOI] == 0}      {set ag::create_whoi "Skip"}
  if {[file exist $ag_tmp::master_data_path/Coastline/wvsplus] == 0} {set ag::create_wvsplus "Skip"}
  if {[file exist $ag_tmp::master_data_path/Coastline/gshhs] == 0} {set ag::create_costline 0}
}

###########################
proc AG_Create_area {how_much} {
  # This is the main proc for generating the datasets for an area...

  qsetenabled $ag_tmp::build_prj_button 0
  set ag_tmp::starttime [clock seconds]

  set ag_tmp::abort 0
  qsetenabled $ag_tmp::abort_button 1

  set ag_tmp::sub 20 
  if {[geodesywidget getcoordinatesystem $ag_tmp::geodesywidget] == "Geodetic" } {
    set ag_tmp::sub 0.020
  }

  zz
  if {[geodesywidget getcoordinatesystem $ag_tmp::geodesywidget] == "Geodetic" } {
    scaz 0.3
  } else {
    scaz 50
  }

  file mkdir "$ag::area_name"
  cd $ag::area_name
  file mkdir Doc

  AG_Set_Nonexisting_2_Skip ;# set pulldowns to "Skip"

  # Open log file
  set ag::logfile_name "$ag_tmp::dir/$ag::area_name/Doc/ag_logfile_$ag_tmp::starttime.txt"
  set ag::Logfile [open $ag::logfile_name w]
  close $ag::Logfile

  AG_Puts 1 "Logfile from Geocap Area Generator"
  AG_Puts 1 "Home dir       : $Geocap::homedir"
  AG_Puts 1 "Master data dir: $ag_tmp::master_data_path"
  AG_Puts 1 "Area Root dir  : $ag_tmp::dir"
  if {$ag_tmp::shelf_loaded == 1} {
    AG_Puts 1 "Geocap Info    : Shelf is loaded"
  } else {
    AG_Puts 1 "Geocap Info    : Shelf is NOT loaded"
  }
  AG_Puts 2 "Date       : [clock format [clock seconds] -format {%d. %B %Y}]"
  AG_Puts 1 "Start time : [clock format [clock seconds] -format {%H:%M:%S  %Z}]"

  AG_Puts 1 "Area Name  : $ag::area_name"
  AG_Puts 1 ""

  AG_Geodesywidget_get
  set ag::Logfile [open $ag::logfile_name a]
  puts $ag::Logfile "--- VITAL PARAMETER LISTING:"
  puts $ag::Logfile "North: $ag::ygeomax   South: $ag::ygeomin"
  puts $ag::Logfile "West : $ag::xgeomin   East : $ag::xgeomax"
  puts $ag::Logfile ""
  puts $ag::Logfile "Geodesy, all parameters listed (relevant or not)"
  puts $ag::Logfile "Datum            : $ag::gw_datum"
  puts $ag::Logfile "Coordinate system: $ag::gw_coordinatesystem"
  puts $ag::Logfile "Central meridian : $ag::gw_centralmeridian"
  puts $ag::Logfile "Origin latitude  : $ag::gw_originlatitude"
  puts $ag::Logfile "False easting    : $ag::gw_falseeasting"
  puts $ag::Logfile "False northing   : $ag::gw_falsenorthing"
  puts $ag::Logfile "Longitude down   : $ag::gw_longitudedown"
  puts $ag::Logfile "Latitude true scale     : $ag::gw_latitudetruescale"
  puts $ag::Logfile "First standard parallel : $ag::gw_firststdparallel"
  puts $ag::Logfile "Second standard parallel: $ag::gw_secondstdparallel"
  puts $ag::Logfile "UTM zone    : $ag::gw_utmzone"
  puts $ag::Logfile "Hemisphere  : $ag::gw_hemisphere"
  puts $ag::Logfile "Scalefactor : $ag::gw_scalefactor"
  puts $ag::Logfile "Longitudeone: $ag::gw_longitudeone"
  puts $ag::Logfile "Longitudetwo: $ag::gw_longitudetwo"
  puts $ag::Logfile "Latitudeone : $ag::gw_latitudeone"
  puts $ag::Logfile "Latitudetwo : $ag::gw_latitudetwo"
  puts $ag::Logfile "------------------------------------"
  close $ag::Logfile

  AG_Puts 1 "Moved to : [pwd]"
  file mkdir Saveset
  AG_Puts 1 "Made dir : Saveset (for saveset with variables = settings)"
  file mkdir Plot
  AG_Puts 1 "Made dir : Plot (directory for postscript plots)"

  file mkdir ag_files
  AG_Puts 1 "Made dir : ag_files (directory for project files. May be deleted after a Geocap project is build)"
  cd ag_files

  # hanker inn alle foldernavn fra master data

  set dirs [glob -nocomplain -types d -directory $ag_tmp::master_data_path *]
  foreach dir $dirs {
    set dirname [file tail $dir]
    file mkdir $dirname
    AG_Puts 1 "Making folder: $dirname"
  }
  file mkdir AG_files
  AG_Puts 1 "Making folder: AG_files"

  ##### Write saveset #####
  if [file exists "$ag_tmp::dir/$ag::area_name/Saveset/saveset_$ag::area_name.tcl"] {
    file copy -force "$ag_tmp::dir/$ag::area_name/Saveset/saveset_$ag::area_name.tcl" "$ag_tmp::dir/$ag::area_name/Saveset/saveset_$ag::area_name.tcl~"
  }
  Geocap::savenamespace ag "$ag_tmp::dir/$ag::area_name/Saveset/saveset_$ag::area_name.tcl"
  AG_Puts 2 "Saved saveset: $ag_tmp::dir/$ag::area_name/Saveset/saveset_$ag::area_name.tcl"

  ##### Global grids - alle grid i folderen blir lest #############
  AG_Read_global_grid ETOPO2v2 store
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}
#?????????? Her er det et eller annet problem dersom sedthic ikke er definert i omrdet....

#Midlertidig fiks - kommenterer vekk sedthick_world
#  AG_Read_global_grid sedthick_world store


  set filelist [glob $ag_tmp::master_data_path/Global_Grids/*.vtk]
  #AG_Puts 1 "Debug filelist: [glob $ag_tmp::master_data_path/Global_Grids/*.vtk]"
  foreach vtk $filelist {
puts $vtk
    set vtk [file tail $vtk]
    set vtk [file rootname $vtk]
    set skip 0

    if {[string match -nocase "ETOPO2" $vtk]}         {set skip 1}
    if {[string match -nocase "sedthick_world" $vtk]} {set skip 1}

    if {[string match -nocase "ETOPO1*" $vtk]     && $ag::generate_etopo1grid == 0}      {set skip 1}
    if {[string match -nocase "GEBCO*" $vtk]      && $ag::generate_gebcogrid == 0}       {set skip 1}
    if {[string match -nocase "GINA*" $vtk]       && $ag::generate_ginagrid == 0}        {set skip 1}
    if {[string match -nocase "SRTM30plus*" $vtk] && $ag::generate_srtm30plusgrid == 0}  {set skip 1}
    if {[string match -nocase "S2004*" $vtk]      && $ag::generate_s2004grid == 0}       {set skip 1}
    if {[string match -nocase "KMS2002*" $vtk]    && $ag::generate_kms2002grid == 0}     {set skip 1}
    if {[string match -nocase "WDMAM*" $vtk]      && $ag::generate_wdmam_ngdc_v1_1 == 0} {set skip 1}
    if {[string match -nocase "EMAG2*" $vtk]      && $ag::generate_emag2_v2 == 0}        {set skip 1}
    if {[string match -nocase "Global_Satellite*" $vtk]   && $ag::generate_glob_sat_grav == 0} {set skip 1}

    if {$skip != 1} {
      AG_Read_global_grid $vtk store
      #AG_Puts 1 "Debug Global_Grids: $vtk"
      AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}
    }
  }

  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}


  ##### End Global_Grids #######################

  ##### Global_Point ###############
  ssc h etopo2

  if [file exist $ag_tmp::master_data_path/Global_Point_DB] {
    set filelist [glob $ag_tmp::master_data_path/Global_Point_DB/*.vtk]
    #AG_Puts 1 "Debug filelist: [glob $ag_tmp::master_data_path/Global_Point_DB/*.vtk]"
    foreach vtk $filelist {
      set vtk [file tail $vtk]
      set vtk [file rootname $vtk]
      AG_Create_global_point $vtk
#      AG_Puts 1 "Debug Global_Point_DB: $vtk"
    }
  }

  mlo etopo2
  ##### End Global_Points #######################

  ##### create 2500 contour
  #set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Creating 2500m contour ..."
  #if {[gvar zmin] < 2500 && [gvar zmax] > 2500 } {
  #  sma v 2500 sav nodis nrg nor

  #  AG_Puts 1 "2500m isobath: punkter foer  mak sortpl 2500m isobath: [gvar numpoint]"
  #  mak sortpl
  #  AG_Puts 1 "2500m isobath: punkter etter mak sortpl 2500m isobath: [gvar numpoint]"
  #  sto AG_files/2500m_isobath.vtk
  #  AG_Puts 1 "Saved: AG_files/2500m_isobath.vtk"
  #  sub $ag_tmp::sub
  #  col 0 0 .8
  #  pol 4
  #}

  mlo etopo2
  dhi *
  dhi ^*
  mhi etopo2

  ##### Coastline ###############

  # Her m jeg sjekke om x-coord strekker seg over 180 datolinjen
  # Gjr muligens en ikke-idiotsikker sjekk.

  if {$ag::create_coastline == 1} {
    file mkdir Coastline/gshhs
    if {$ag::etopo2_display_minimum != 1} {AG_Gen_coastline f}
    AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}
    if {$ag::etopo2_display_minimum != 1} {AG_Gen_coastline h}
    AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}
    if {$ag::etopo2_display_minimum != 1} {AG_Gen_coastline i}
    AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}
    AG_Gen_coastline l
    AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}
    AG_Gen_coastline c
    AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}
  }
  ##### End Coastline ###############


  mlo etopo2
  dhi *
  dhi ^*
  mhi etopo2

  ##### --- SPIN THROUGH ---

  zz

  # --- BGR
  if {$ag::create_bgr != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      AG_Spin_through BGR no_subdir BGR folders collect lines
    }
    # Syntax: AG_Spin_through maindir subfolder splitname organized_as topology
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- BSH
  if {$ag::create_bsh != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      AG_Spin_through BSH no_subdir BSH_Bathymetry data collect lines
      AG_Spin_through BSH no_subdir BSH_Trackline data collect lines
    }
    if {$ag::include_multibeam != "Skip all multibeam"} {
      AG_Spin_through BSH no_subdir BSH_MultiBeam folders nocollect freepoints
    }
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- Coastline/wvsplus
  if {$ag::create_wvsplus != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      #AG_Spin_through Coastline wvsplus wvsplus data nocollect lines
      AG_Spin_through Coastline wvsplus wvsplus data nocollect keepstructure

      set file "Coastline/wvsplus/wvsplus"
      AG_Read_and_convert_lines $file.vtk relative_path line
      # hvis isgrid == 99 s er alle punkter slettet. Blh - for en test. 
      if {[gvar isgrid] != 99 && [gvar numpoint] > 0} {
        # The reason for using _all is that the folder wvsplus already exists, and would
        # if just called wvsplus.vtk cause an error when building the project.
        sto ${file}_all.vtk
        AG_Puts 2 "Saved: ${file}_all.vtk"
      }
    }
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- ECS
  if {$ag::create_ecs != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      #AG_Spin_through ECS no_subdir ECS_lines data collect lines
      AG_Spin_through ECS no_subdir ECS_lines data collect keepstructure
    }
  }

  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- GA_GOV_AU
  if {$ag::create_ga_gov_au != "Skip"} {
    if {$ag::include_multibeam != "Skip all multibeam"} {
      AG_Spin_through GA_GOV_AU no_subdir GA_GOV_AU_MULTIBEAM folders nocollect freepoints
    }
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- Geodas
  if {$ag::create_geodas != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      AG_Spin_through Geodas no_subdir Geodas folders collect lines
      if {[file exists $ag_tmp::master_data_path/Geodas/Geodas_Magnet_MinMax]} {
        AG_Spin_through Geodas no_subdir Geodas_Magnet folders collect lines
      }
    }
    if {$ag::include_multibeam != "Skip all multibeam"} {
      if {[file exists $ag_tmp::master_data_path/Geodas/Geodas_Multibeam_MinMax]} {
        AG_Spin_through Geodas no_subdir Geodas_Multibeam folders nocollect freepoints
      }
    }
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- GMBD
  if {$ag::create_gmbd != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      #AG_Spin_through GMBD no_subdir GMBD_Lines data nocollect lines
      AG_Spin_through GMBD no_subdir GMBD_Lines data nocollect keepstructure
      #AG_Spin_through GMBD no_subdir GMBD_Detailed_Lines folders nocollect lines
      AG_Spin_through GMBD no_subdir GMBD_Detailed_Lines folders nocollect keepstructure
      AG_Spin_through GMBD no_subdir GMBD_Polygons folders nocollect polygons
    }
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- Ifremer
  if {$ag::create_ifremer != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      AG_Spin_through Ifremer no_subdir Ifremer folders collect lines
    }
    if {$ag::include_multibeam != "Skip all multibeam"} {
      AG_Spin_through Ifremer no_subdir Ifremer_MultiBeam data nocollect freepoints
    }
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- IPGS
  if {$ag::create_ipgs != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      AG_Spin_through IPGS no_subdir IPGS folders collect lines
    }
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- JAMSTEC
  if {$ag::create_jamstec != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      #AG_Spin_through JAMSTEC no_subdir KAIREI_Tokyo_Datum folders collect keepstructure - koblet ut pga. en feil
      AG_Spin_through JAMSTEC no_subdir KAIREI_WGS_84 folders collect lines
      #AG_Spin_through JAMSTEC no_subdir MIRAI_Tokyo_Datum folders collect keepstructure - koblet ut pga. en feil
      AG_Spin_through JAMSTEC no_subdir MIRAI_WGS_84 folders collect lines
      AG_Spin_through JAMSTEC no_subdir NATSUSHIMA_WGS_84 folders collect lines
      AG_Spin_through JAMSTEC no_subdir YOKOSUKA_Tokyo_Datum folders collect lines
      AG_Spin_through JAMSTEC no_subdir YOKOSUKA_WGS_84 folders collect lines
      # --- JAMSTEC_new
      AG_Spin_through JAMSTEC no_subdir JAMSTEC_Tokyo_Datum folders collect lines
      AG_Spin_through JAMSTEC no_subdir JAMSTEC_WGS_84 folders collect lines
      AG_Spin_through JAMSTEC no_subdir JAMSTEC_Trackline data collect lines
    }
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- JODC
  if {$ag::create_jodc != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      AG_Spin_through JODC no_subdir JODC folders collect lines
    }
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- MG_DMS
  if {$ag::create_mg_dms != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      AG_Spin_through MG_DMS no_subdir MG_DMS folders collect lines
    }
    if {$ag::include_multibeam != "Skip all multibeam"} {
      AG_Spin_through MG_DMS no_subdir MG_DMS_MultiBeam folders nocollect freepoints
    }
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}


#  # --- MG_DMS
#  if {$ag::create_mg_dms != "Skip"} {
#    if {$ag::include_multibeam != "Skip all multibeam"} {
#      AG_Spin_through MG_DMS no_subdir MG_DMS_MultiBeam folders nocollect freepoints
#    }
#  }
#  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- Scripps
  if {$ag::create_scripps != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      AG_Spin_through Scripps no_subdir Scripps_Bathymetry data collect lines
      AG_Spin_through Scripps no_subdir Scripps folders collect lines
    }
    if {$ag::include_multibeam != "Skip all multibeam"} {
      AG_Spin_through Scripps no_subdir Scripps_Multibeam folders nocollect freepoints
    }
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- Norway
  if {$ag::create_norway_sea != "Skip"} {
    set ag_tmp::norway "sea"
    AG_Spin_through Norway no_subdir Norway_UTM33_Seabed data collect freepoints
    AG_Spin_through Norway no_subdir Dybdedata50m data collect freepoints
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  if {$ag::create_norway_land != "Skip"} {
    set ag_tmp::norway "land"
    AG_Spin_through Norway no_subdir Norway_UTM33_Land data collect freepoints
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}



  # --- SeaDOG
  if {$ag::create_seadog != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      AG_Spin_through SeaDOG no_subdir SeaDOG folders collect lines
    }
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- UN_Boundaries_01
  if {$ag::create_un_boundaries_01 != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      #AG_Spin_through UN_Boundaries_01 no_subdir UN_Coastline_01M folders collect lines
      #AG_Spin_through UN_Boundaries_01 no_subdir UN_IntBoundaries_01M data collect lines
      AG_Spin_through UN_Boundaries_01 no_subdir UN_IntBoundaries_01M data collect keepstructure
      #AG_Spin_through UN_Boundaries_01 no_subdir UN_IntBoundaries_line_01M data collect lines
      AG_Spin_through UN_Boundaries_01 no_subdir UN_IntBoundaries_line_01M data collect keepstructure
      AG_Spin_through UN_Boundaries_01 no_subdir UN_IntBoundaries_poly_01M data collect polygons
      #AG_Spin_through UN_Boundaries_01 no_subdir UN_Lakes_line_01M data collect lines
      AG_Spin_through UN_Boundaries_01 no_subdir UN_Lakes_line_01M data collect keepstructure
      AG_Spin_through UN_Boundaries_01 no_subdir UN_Lakes_poly_01M data collect polygons
    }
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- UTIG
  if {$ag::create_utig != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      AG_Spin_through UTIG no_subdir UTIG folders collect keepstructure
    }
    # Syntax: AG_Spin_through maindir subfolder splitname organized_as topology
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- USGS
  if {$ag::create_usgs != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      AG_Spin_through USGS no_subdir USGS folders collect keepstructure
    }
    # Syntax: AG_Spin_through maindir subfolder splitname organized_as topology
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  # --- WHOI
  if {$ag::create_whoi != "Skip"} {
    if {$ag::include_multibeam != "Generate multibeam only"} {
      AG_Spin_through WHOI no_subdir WHOI_Trackline data collect lines
    }
    if {$ag::include_multibeam != "Skip all multibeam"} {
      AG_Spin_through WHOI no_subdir WHOI_Multibeam folders nocollect freepoints
    }
  }
  AG_Check_if_abort; if {$ag_tmp::abort == 1} {return}

  ##### UN datasets, always included (hvis det eksisterer) ###############
  if [file exist $ag_tmp::master_data_path/UN_Boundaries_01] {
    set file "UN_Boundaries_01/UN_Lakes_01M"
    AG_Read_and_convert_lines $file.vtk relative_path polygon
    # hvis isgrid == 99 s er alle punkter slettet. Blh - for en test. 
    if {[gvar isgrid] != 99 && [gvar numpoint] > 0} {
      sto ${file}_all.vtk
      AG_Puts 2 "Saved: ${file}_all.vtk"
    }

    set file "UN_Boundaries_01/UN_IntBoundaries_01M"
    AG_Read_and_convert_lines $file.vtk relative_path line

    # hvis isgrid == 99 s er alle punkter slettet. Blh - for en test. 
    if {[gvar isgrid] != 99 && [gvar numpoint] > 0} {
      # The reason for using _all is that the folder wvsplus already exists, and would
      # if just called wvsplus.vtk cause an error when building the project.
      sto ${file}_all.vtk
      AG_Puts 2 "Saved: ${file}_all.vtk"
    }

    set file "UN_Boundaries_01/UN_IntBoundaries_poly_01M"
    AG_Read_and_convert_lines $file.vtk relative_path polygon
    # hvis isgrid == 99 s er alle punkter slettet. Blh - for en test. 
    if {[gvar isgrid] != 99 && [gvar numpoint] > 0} {
      sto ${file}_all.vtk
      AG_Puts 2 "Saved: ${file}_all.vtk"
    }

    set file "UN_Boundaries_01/UN_Coastline_01M"
    AG_Read_and_convert_lines $file.vtk relative_path line
    # hvis isgrid == 99 s er alle punkter slettet. Blh - for en test. 
    if {[gvar isgrid] != 99 && [gvar numpoint] > 0} {
      sto ${file}_all.vtk
      AG_Puts 2 "Saved: ${file}_all.vtk"
    }
  }
  ##### END UN datasets ###############

  # --- Industry
  if [file exist $ag_tmp::master_data_path/Industry] {
    if {$ag::create_industry != "Skip"} {
      # Hmmm - m skrive om denne slik at man kan legge inn hva man vil her........
      if [file exist $ag_tmp::master_data_path/Industry/Africa_WesternGeco] {
        # mtte bare sjekke at 'Africa_WesternGeco' eksisterte - de fleste vil jo ikke ha disse dataene...
        AG_Spin_through Industry Africa_WesternGeco Africa_WesternGeco data collect keepstructure
      }
      if [file exist $ag_tmp::master_data_path/Industry/WestAfrica_CGGVeritas] {
        AG_Spin_through Industry WestAfrica_CGGVeritas WestAfrica_CGGVeritas data collect keepstructure
      }
      if [file exist $ag_tmp::master_data_path/Industry/IMR/F.Nansen_VTK] {
        AG_Spin_through Industry IMR F.Nansen data collect keepstructure
      }
      if [file exist $ag_tmp::master_data_path/Industry/IMR/F.Nansen_VTK] {
        AG_Spin_through Industry IMR F.Nansen data collect keepstructure
      }
    }
  }

  # Her er mye klippet ut - ligger i ag_utklipp.txt

  AG_Delete_empty_subfolders_recursively $ag_tmp::dir/$ag::area_name/ag_files

  #asc
  cd "$ag_tmp::dir"

  AG_Stopp_klokken
  set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Done. 
                         <BR>Directory $ag_tmp::dir/$ag::area_name created
                         <BR>with subfolders. ( $how_much ) <BR>Elapsed time: $ag_tmp::elapsed"

  AG_Puts 2 "Time elapsed: $ag_tmp::elapsed"
  qinformation "Files on disk completed" "Total time elapsed: $ag_tmp::elapsed

  Check the folder and file structure on disk. If you now
  press the 'Build project' button, the project built will
  reflect the files and folders found under
  $ag_tmp::dir/$ag::area_name/ag_files
  "

  qsetenabled $ag_tmp::build_prj_button 1
}

####################
proc AG_Addline {tykkelse hiname action} {
  mlo base
  sub lo etopo2

  mul $tykkelse
  add lo base
  mhi tmp2

  mlo trace_dense
  zap tmp2
  mhi $hiname
  mlo lines app
  dhi lines
  mhi lines
}

####################
proc AG_Display_xsect {L1 L2 r g b} {
  set i 0
  mlo C1
  set no_of_cells [gvar numcell]
  while {$i < $no_of_cells} {
    mlo $L1
    mak cel $i
    mhi tmp
    mlo $L2
    mak cel $i
    #mak gcrev
    #mlo tmp app
    #mak lin
    #mak cpl
    #mak sha
    mak tris tmp
    col $r $g $b
    dis
    if {$i == 0} {mhi tmp_1}
    if {$i != 0} {
      mlo tmp_1 app
      dhi tmp_1
      mhi tmp_1
    }
    incr i
  }
}

##############################
proc AG_Make_geotrans {} {
  # M returnere om jeg kommer inn med et tomt datasett.
  if {[gvar numpoint] == 0} {return}
  if {[geodesywidget getcoordinatesystem $ag_tmp::geodesywidget] != "Geodetic" } {
    # Dropper all konvertering om koord-syst = Geodetic.
    geo set coord Geodetic
    geo set datum "WGE"
    geodesywidget setaslower $ag_tmp::geodesywidget
    #geo set low cenmer 40 ;# dummy i pvente av fiks for Van der Grinten
    #geo set cenmer 40 ;# dummy i pvente av fiks for Van der Grinten
    geo cvt coord 
  }
}
##############################
proc AG_Make_geotrans_old {} {
  geo set datum WGE 
  geo set low datum WGE 
  geo set feasting 0 
  geo set fnorthing 0
  geo set hem $ag::hemisphere
  geo set low coord Geodetic
  if {$ag::projection == "Mercator"} {
    geo set coord "Mercator"
    geo set cenmer $ag::central_mer   ;# central meridian
    geo set orglat 0    ;# origin latitude
    geo cvt low coord   ;# convert from lower to upper
  } elseif {$ag::projection == "UTM"} {
    geo set coord "Universal Transverse Mercator (UTM)"
    geo set datum EUR-7 
    geo set low datum EUR-7 
    geo set zone $ag::utm_zone
    geo cvt low coord 
  } elseif {$ag::projection == "Polar Stereographic" } {
    geo set coord "Polar Stereographic"
    geo set downlon 0
    geo set truelat $ag::truelat
    geo cvt low coord 
  } elseif {$ag::projection == "Eckert VI" } {
    geo set coord "Eckert VI"
    geo cvt low coord 
  } elseif {$ag::projection == "Geographic"} {
    #do nothing
  }
}

# --- eof