# --- File  : ag_projection.tcl
# --- Date  : 06-Jun-2006
# --- By    : Harald Sund
# --- About : Panel for projection settings. Ikke i bruk lenger... etter at geodesy widget ble lagt inn.


#####################
proc AG_Check_combo {dummy} {
  AG_Set_projection
  qprocessevents
}

set ag_tmp::projection_2bset $ag::projection 

# sjekk om variable eksisterer
if {[info exists ag_tmp::panel_projections]} {
  # sjekk om panelet eksisterer
  if [qexists $ag_tmp::panel_projections] {
    qinformation "Warning" "You cannot start multiple sessions of this panel. <BR>The panel is present somewhere"
    return
  }
}

# ----------------------#
# ---- Start panel ---- #
# ----------------------#

set ag_tmp::panel_projections [qwidget $ag_tmp::main_panel window] 
qsetattribute deleteonclose
qsetwindowtitle "Projection settings"

qgridlayout {
  qsetspacing 4

  qlabel "Projection : "
  qcombobox {AG_Check_combo}
  qblockedtrace ag_tmp::projection_2bset
  qadditems {"Not selected" "Geographic" "Mercator" "UTM" "Polar Stereographic" "Eckert VI"}

  qnewgridline

  qlabel "Hemisphere setting : "
  qcombobox {AG_Check_combo}
  qadditems {"N" "S"}
  qblockedtrace ag::hemisphere

  qnewgridline

  qlabel "Mercator Central Meredian : "
  qcombobox {AG_Check_combo}
  qadditems {"0" "180"}
  qseteditable 1
  qblockedtrace ag::central_mer

  qnewgridline

  qlabel "UTM Zone : "
  qcombobox {AG_Check_combo}
  qadditems {"31" "32" "34"}
  qseteditable 1
  qblockedtrace ag::utm_zone

  qnewgridline

  qlabel "Polar Stereographic True lattitude "
  qcombobox {AG_Check_combo}
  qadditems {"-65" "75"}
  qseteditable 1
  qblockedtrace ag::truelat

  qnewgridline

  qpushbutton "Exit and set projections" {
    qdelete $ag_tmp::panel_projections
    AG_Set_projection
  }
  qsetmargin 8
}
qshow $ag_tmp::panel_projections

# --- eof