# --- File  : ag_pulldowns.tcl
# --- Date  : 01-Mar-2005
# --- By    : Harald Sund
# --- About : Pulldowns

# ---- Lager frste pulldown, nemlig "File"
set ag_tmp::pd_mainpanel_File [qaction "File"]
# Setter den p hovedpanelet, main_panel"
qaddaction [qmenubar $ag_tmp::main_panel] $ag_tmp::pd_mainpanel_File
# Lager en qmenu-widget
set ag_tmp::pdmnu_mainpanel_File [qmenu]
# Legger qmnu-widget p pulldownen
qsetmenu $ag_tmp::pd_mainpanel_File $ag_tmp::pdmnu_mainpanel_File

# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_File [
  qaction "Read saveset ..." {
    AG_My_open_a_agfile saveset*.tcl
    if {$ag_tmp::filename != ""} {
      source $ag_tmp::path/ag_init_var.tcl
      source "$ag_tmp::filename"
      AG_Geodesywidget_set
      puts "Sourced: $ag_tmp::filename"
      #set ag_tmp::master_data_path $ag_tmp::dir/../master_data
      source $ag_tmp::path/ag_init.tcl
      set ag_tmp::label1 "<B><FONT COLOR=#0000AA>Saveset for $ag::area_name read"
    }
  }
]
qseticon [qicon $ag_tmp::path/icons/fileopen.xpm]

# Dette droppes - AM har lagt inn save graphics as ... vrml
### # --- legger en entry p pulldown
### qaddaction $ag_tmp::pdmnu_mainpanel_File [
###   qaction "Export current display as vrml ..." {
###     source $ag_tmp::path/ag_vrml_write.tcl
###   }
### ]
### qseticon [qicon $ag_tmp::path/icons/filesave.xpm]

# --- legger en entry p pulldown

if {$ag_tmp::minimized == 0} {
  qaddaction $ag_tmp::pdmnu_mainpanel_File [
    qaction "Minimize" {
      AG_Minimize
    }
  ]
} else {
  qaddaction $ag_tmp::pdmnu_mainpanel_File [
    qaction "Maximize" {
      qdelete $ag_tmp::main_panel
      source $ag_tmp::path/ag_index.tcl
    }
  ]
}
qaddaction $ag_tmp::pdmnu_mainpanel_File [
  qaction "Exit" {
    qdelete $ag_tmp::main_panel
  }
]

# ---- Lager neste pulldown, nemlig "View"
set ag_tmp::pd_mainpanel_View [qaction "View"]
# Setter den p hovedpanelet, main_panel"
qaddaction [qmenubar $ag_tmp::main_panel] $ag_tmp::pd_mainpanel_View
# Lager en qmenu-widget
set ag_tmp::pdmnu_mainpanel_View [qmenu]
# Legger qmnu-widget p pulldownen
qsetmenu $ag_tmp::pd_mainpanel_View $ag_tmp::pdmnu_mainpanel_View

# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_View [
  qaction "Preview topographic view" {
    set ag_tmp::previewtype "map_nor"
    source $ag_tmp::path/ag_preview_topo.tcl
  }
]
qseticon [qicon $ag_tmp::path/icons/land+sea.png]

# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_View [
  qaction "Preview topographic view detailed LOD" {
    set ag_tmp::previewtype "lod"
    source $ag_tmp::path/ag_preview_topo.tcl
  }
]
qseticon [qicon $ag_tmp::path/icons/seabed_mesh.png]

# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_View [
  qaction "Preview topographic view detailed LOD range" {
    set ag_tmp::previewtype "lod_range"
    source $ag_tmp::path/ag_preview_topo.tcl
  }
]
qseticon [qicon $ag_tmp::path/icons/seabed_mesh.png]

# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_View [
  qaction "Preview topographic view detailed LOD range reduced land" {
    set ag_tmp::previewtype "lod_reduced_land"
    source $ag_tmp::path/ag_preview_topo.tcl
  }
]
qseticon [qicon $ag_tmp::path/icons/seabed_mesh.png]

# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_View [
  qaction "Preview topographic view detailed LOD Color" {
    set ag_tmp::previewtype "lod_color"
    source $ag_tmp::path/ag_preview_topo.tcl
  }
]
qseticon [qicon $ag_tmp::path/icons/map_mesh.png]









# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_View [
  qaction "SRTM grid in preview" {
    set ag_tmp::previewtype "srtm"
    source $ag_tmp::path/ag_preview_topo.tcl
  }
]
qseticon [qicon $ag_tmp::path/icons/map_mesh.png]
























# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_View [
  qaction "Preview selected area in world context (and select new area)" {
    source $ag_tmp::path/ag_preview_geo.tcl
  }
]
qseticon [qicon "$ag_tmp::path/icons/preview_geo.png"] 



# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_View [
  qaction "Convert+display a line-file from master db on topo view" {
    set filename [qopenfilename $ag_tmp::master_data_path/*.vtk]
    if {$filename != ""} {
      AG_Read_and_convert_lines $filename absolute_path keepstructure
      pol 2
    }
  }
]

# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_View [
  qaction "Display a vtk-file from master db onto world preview" {
    set filename [qopenfilename $ag_tmp::master_data_path/*.vtk]
    if {$filename != ""} {
      rea $filename
      #mak lin
      mul 0
      if {[gvar numcell] == 0} {
        poi
      } else {
        pol 2
      }
    }
  }
]

# ---- Lager neste pulldown, nemlig "Tools"
set ag_tmp::pd_mainpanel_Tools [qaction "Tools"]
# Setter den p hovedpanelet, main_panel"
qaddaction [qmenubar $ag_tmp::main_panel] $ag_tmp::pd_mainpanel_Tools
# Lager en qmenu-widget
set ag_tmp::pdmnu_mainpanel_Tools [qmenu]
# Legger qmnu-widget p pulldownen
qsetmenu $ag_tmp::pd_mainpanel_Tools $ag_tmp::pdmnu_mainpanel_Tools


# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_Tools [
  qaction "Settings ..." {
    source $ag_tmp::path/ag_settings.tcl
  }
]
qseticon [qicon $ag_tmp::path/icons/settings.png]

# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_Tools [
  qaction "Quick dataviewer ..." {
    source $ag_tmp::path/ag_dataviewer.tcl
  }
]
qsetenabled 0

# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_Tools [
  qaction "Save directory setup ..." {
    source $ag_tmp::path/ag_directory_setup.tcl
  }
]

# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_Tools [
  qaction "Run the Area-generator DB" {
    source $ag_tmp::path/ag_db_creator.tcl
  }
]

# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_Tools [
  qaction "Read Etopo1_Bed_g into current projection and window" {
    AG_Read_global_grid ETOPO1_Bed_g nostore
    qinformation "Information" "ETOPO1_Bed_g is read and present in workspace 'active'.

To put it into your project, right-click on a 
folder > Add > Workspace Data > active

Then rename the entry in the project afterwards."
  }
]

# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_Tools [
  qaction "Read Etopo1_Ice_g into current projection and window" {
    AG_Read_global_grid ETOPO1_Ice_g nostore
    qinformation "Information" "ETOPO1_Ice_g is read and present in workspace 'active'.

To put it into your project, right-click on a project
folder > Add > Workspace Data > active

Then rename the entry in the project afterwards."
  }
]

# ---- Lager neste pulldown, nemlig "Builder"
set ag_tmp::pd_mainpanel_Builder [qaction "Builder"]
# Setter den p hovedpanelet, main_panel"
qaddaction [qmenubar $ag_tmp::main_panel] $ag_tmp::pd_mainpanel_Builder
# Lager en qmenu-widget
set ag_tmp::pdmnu_mainpanel_Builder [qmenu]
# Legger qmnu-widget p pulldownen
qsetmenu $ag_tmp::pd_mainpanel_Builder $ag_tmp::pdmnu_mainpanel_Builder

# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_Builder [
  qaction "Read and show all DEMs ag_build_dems.tcl" {
    source $ag_tmp::path/ag_build_dems.tcl
  }
]
# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_Builder [
  qaction "Read and create minmax for all XYZ 50mseabed ag_build_norway_seabed_50m.tcl" {
    source $ag_tmp::path/ag_build_norway_seabed_50m.tcl
  }
]

# ---- Lager neste pulldown, nemlig "Help"
set ag_tmp::pd_mainpanel_Help [qaction "Help"]
# Setter den p hovedpanelet, main_panel"
qaddaction [qmenubar $ag_tmp::main_panel] $ag_tmp::pd_mainpanel_Help
# Lager en qmenu-widget
set ag_tmp::pdmnu_mainpanel_Help [qmenu]
# Legger qmnu-widget p pulldownen
qsetmenu $ag_tmp::pd_mainpanel_Help $ag_tmp::pdmnu_mainpanel_Help

# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_Help [
  qaction "Step-by-step guide" {
    AG_View_file "$ag_tmp::path/ag_help.txt" "Step by step Guide to the Area Generator"
  }
]
qseticon [qicon $ag_tmp::path/icons/page_white_text.png]


# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_Help [
  qaction "Script example of making 1 minute lines" {
    AG_View_file "$ag_tmp::path/ag_help_1min_lines.txt" "Example of making a 1min line dataset"
  }
]

# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_Help [
  qaction "About" {
    qinformation "About $ag_tmp::prog_name" "<p>Copyright  &copy; 2005-2064 by Andeby Geo.

<p>Installation directory: $ag_tmp::path

<p>Please send comments, error messages and other feedback
to <a href=mailto:harald.sund@andeby.no>harald.sund@andeby.no</a>
" "Close"
  }
]

# --- legger en entry p pulldown
qaddaction $ag_tmp::pdmnu_mainpanel_Help [
  qaction "Check for updates" {
    AG_open_browser "http://geocap.onconfluence.com/display/ext/Area+Generator/"
  }
]

# --- eof
