# --- File  : ag_settings.tcl
# --- Date  : 29-Nov-2005
# --- By    : Harald Sund
# --- About : Settings panel

# sjekk om variable eksisterer
if {[info exists ag_tmp::panel_settings]} {
  # sjekk om panelet eksisterer
  if [qexists $ag_tmp::panel_settings] {
    qinformation "Warning" "You cannot start multiple sessions of this panel. <BR>The panel is present somewhere"
    return
  }
}

# ----------------------#
# ---- Start panel ---- #
# ----------------------#

set ag_tmp::panel_settings [qwidget $ag_tmp::main_panel window] 
qsetattribute deleteonclose
qsetwindowtitle "Settings"

qgridlayout {
  qsetspacing 0


  qcheckbox "Skip accumulating datasets into all_ datasets"
  qblockedtrace ag::skip_accumulating
  qsettooltip "This may avoid a crash when working with large areas"

  # Linjene under ble kommentert vekk 4/7-2007.
  #qlabel "<B> -------------------- PROJECT TYPE --- </B>"
  #qnewgridline ;# ----------------------------------
  #qcheckbox "Create a packed project (as opposed to a file-pointer project)"
  #qblockedtrace ag::skip_filepointers
  #qnewgridline ;# ----------------------------------

  qnewgridline ;# ----------------------------------
  qlabel "<B> -------------------- TRACK LINES --- </B>"

  qnewgridline ;# ----------------------------------

  qcheckbox "Display ship track lines"
  qsetenabled 0
  qblockedtrace ag::display_tracklines

  qnewgridline ;# ----------------------------------

  qlabel "<B> -------------------- COASTLINE --- </B>"

  qnewgridline ;# ----------------------------------

  qcheckbox "Skip sorting detailed coastline (some coastlines may be too big to sort))"
  qblockedtrace ag::skip_sorting_coast

  qnewgridline ;# ----------------------------------

  qcheckbox "Generate connected test-coast (time_consuming)"
  qblockedtrace ag::use_lines_in_testcoast

  qnewgridline ;# ----------------------------------

  qlabel "<B> -------------------- DISPLAY --- </B>"

  qnewgridline ;# ----------------------------------
  qcheckbox "Drop most displays & don't generate detailed coast"
  qblockedtrace ag::etopo2_display_minimum

  qnewgridline ;# ----------------------------------

  qcheckbox "Display earth surface in reduced resolution"
  qsetenabled 0
  qblockedtrace ag::etopo2_display_reduced

  qnewgridline ;# ----------------------------------

  qcheckbox "Display earth surface with smooth shading"
  qsetenabled 0
  qblockedtrace ag::etopo2_display_smooth

  qnewgridline ;# ----------------------------------

  qcheckbox "Reduce land height (NB! Then Seabed relief != Land Relief)"
  qblockedtrace ag::etopo2_reduce_land_height

  qnewgridline ;# ----------------------------------

  qcheckbox "Skip land display"
  qsetenabled 0
  qblockedtrace ag::etopo2_skip_land_display

  qnewgridline ;# ----------------------------------

  qcheckbox "Activate debug mode"
  qsetenabled 1
  qblockedtrace ag_tmp::debug

  qnewgridline ;# ----------------------------------
  qlabel "Alternative location for grid2vtk.exe"
  qlabel " : "
  qlabel
  qblockedtrace ag_tmp::grid2vtk_located
  qsettooltip "If you IT admin has blocked *.exe files outide of c:/program files...."

  qpushbutton "Browse" {
    AG_My_open_a_agfile *.exe
    set ag_tmp::grid2vtk_located $ag_tmp::filename
  }
  qseticon [qicon $ag_tmp::path/icons/fileopen.xpm]

  qsetmargin 5
}
qshow $ag_tmp::panel_settings

# --- eof
